package com.pipipifa.pilaipiwang.goodselect.api

import com.google.gson.reflect.TypeToken
import com.pipipifa.pilaipiwang.goodselect.model.*
import com.pipipifa.pilaipiwang.model.user.User
import com.pipipifa.pilaipiwang.net.Cmd
import com.ppwang.ppbase.base.net.param.ServerValue

object UselectSevice {

    /**
     * 申请退款(cmd51000)
     */
    @JvmStatic
    fun creatParam51000(user: User, ppOrderId: String, refundType: Int, refundReasonTypeId: String?, reason: String?, proofImages: ArrayList<String>, refundGoods: ArrayList<UselectUpGoosBean>): ServerValue {
        val value = ServerValue()
        value.setCmd(Cmd.REQUEST_CODE_51000)
        value.addParam("token", user.token)
        value.addParam("user_id", user.userId)
        value.addParam("ppOrderId", ppOrderId)
        value.addParam("refundType", refundType)
        value.addParam("refundReasonTypeId", refundReasonTypeId)
        value.addParam("reason", reason)
        value.addParam("proofImages", proofImages)
        value.addParamList("refundGoods", refundGoods)
        value.setDataClass(UselectApplyRefundBean::class.java)
        return value
    }

    /**
     * 退款原因列表(cmd51002)
     */
    @JvmStatic
    fun creatParam51002(): ServerValue {
        val value = ServerValue()
        value.setCmd(Cmd.REQUEST_CODE_51002)
        value.setDataClass(UselectRefundReasonBean::class.java)
        return value
    }

    /**
     * 退货退款详情(cmd51001)
     */
    @JvmStatic
    fun creatParam51001(user: User, userType: Int, ppyxRefundId: String): ServerValue {
        val value = ServerValue()
        value.setCmd(Cmd.REQUEST_CODE_51001)
        value.addParam("token", user.token)
        value.addParam("user_id", user.userId)
        value.addParam("userType", userType)
        value.addParam("ppOrderId", ppyxRefundId)
        value.setDataClass(UselectRefundDetailBean::class.java)
        return value
    }

    /**
     * 可退货商品详情(cmd51009)
     */
    @JvmStatic
    fun creatParam51009(user: User, ppOrderId: String): ServerValue {
        val value = ServerValue()
        value.setCmd(Cmd.REQUEST_CODE_51009)
        value.addParam("token", user.token)
        value.addParam("ppOrderId", ppOrderId)
        value.addParam("user_id", user.userId)
        value.setDataClass(UselectRefundGoodsBean::class.java)
        return value
    }

    /**
     * 优选|退货退款|协商记录(cmd51003)
     */
    @JvmStatic
    fun creatParam51003(user: User, ppOrderId: String, userType: Int): ServerValue {
        val value = ServerValue()
        value.setCmd(Cmd.REQUEST_CODE_51003)
        value.addParam("token", user.token)
        value.addParam("ppOrderId", ppOrderId)
        value.addParam("userType", userType)
        value.addParam("user_id", user.userId)
        value.setDataClass(UselectConsultationRecordBean::class.java)
        return value
    }

    /**
     * 优选|退货退款|退款历程(cmd51004)
     */
    @JvmStatic
    fun creatParam51004(user: User, ppOrderId: String): ServerValue {
        val value = ServerValue()
        value.setCmd(Cmd.REQUEST_CODE_51004)
        value.addParam("token", user.token)
        value.addParam("ppOrderId", ppOrderId)
        value.addParam("user_id", user.userId)
        value.setDataClass(UselectProcessBean::class.java)
        return value
    }


    /**
     * 优选|退货退款|取消退款(cmd51005)
     */
    @JvmStatic
    fun creatParam51005(user: User, ppOrderId: String): ServerValue {
        val value = ServerValue()
        value.setCmd(Cmd.REQUEST_CODE_51005)
        value.addParam("token", user.token)
        value.addParam("ppOrderId", ppOrderId)
        value.addParam("user_id", user.userId)
        value.dataClass = Boolean::class.java
        return value
    }


    /**
     * 优选|退货退款|买家寄回快递(cmd51006)
     */
    @JvmStatic
    fun creatParam51006(user: User, ppOrderId: String, expressCode: String, expressSn: String): ServerValue {
        val value = ServerValue()
        value.setCmd(Cmd.REQUEST_CODE_51006)
        value.addParam("token", user.token)
        value.addParam("ppOrderId", ppOrderId)
        value.addParam("user_id", user.userId)
        value.addParam("expressCode", expressCode)
        value.addParam("expressSn", expressSn)
        value.dataClass = Boolean::class.java
        return value
    }

    /**
     * 优选|退货退款|获取退货地址(cmd51007)
     */
    @JvmStatic
    fun creatParam51007(user: User, ppOrderId: String): ServerValue {
        val value = ServerValue()
        value.setCmd(Cmd.REQUEST_CODE_51007)
        value.addParam("token", user.token)
        value.addParam("ppOrderId", ppOrderId)
        value.addParam("user_id", user.userId)
        value.setDataClass(UselectRefundAddreaBean::class.java)
        return value
    }

    /**
     * 优选|退货退款|快递公司列表(cmd51008)
     */
    @JvmStatic
    fun creatParam51008(user: User, ppOrderId: String): ServerValue {
        val value = ServerValue()
        value.setCmd(Cmd.REQUEST_CODE_51008)
        value.addParam("token", user.token)
        value.addParam("ppOrderId", ppOrderId)
        value.addParam("user_id", user.userId)
        value.setDataClass(UselectSelectCounierBean::class.java)
        return value
    }

    /**
     * 优选|退货退款仲裁|买家申请仲裁(51100)
     */
    @JvmStatic
    fun creatParam51100(user: User, ppOrderId: String, reason: String, mSuccessImages: ArrayList<String>): ServerValue {
        val value = ServerValue()
        value.setCmd(Cmd.REQUEST_CODE_51100)
        value.addParam("token", user.token)
        value.addParam("ppOrderId", ppOrderId)
        value.addParam("user_id", user.userId)
        value.addParam("reason", reason)
        value.addParam("proofJson", mSuccessImages)
        value.dataClass = Boolean::class.java
        return value
    }

    /**
     * 优选|退货退款仲裁|仲裁详情(cmd51102)
     */
    @JvmStatic
    fun creatParam51102(user: User, ppOrderId: String, refundType: Int): ServerValue {
        val value = ServerValue()
        value.setCmd(Cmd.REQUEST_CODE_51102)
        value.addParam("token", user.token)
        value.addParam("ppOrderId", ppOrderId)
        value.addParam("user_id", user.userId)
        value.addParam("userType", refundType)
        value.setDataClass(UselectArbitrationDetailBean::class.java)
        return value
    }

    /**
     * 优选|退货退款仲裁|买家取消仲裁(cmd51101)
     */
    @JvmStatic
    fun creatParam51101(user: User, ppOrderId: String): ServerValue {
        val value = ServerValue()
        value.setCmd(Cmd.REQUEST_CODE_51101)
        value.addParam("token", user.token)
        value.addParam("ppOrderId", ppOrderId)
        value.addParam("user_id", user.userId)
        value.dataClass = Boolean::class.java
        return value
    }

    /**
     * 优选|退货退款仲裁|买家寄回快递物流追踪(cmd51010)
     */
    @JvmStatic
    fun creatParam51010(user: User, ppOrderId: String, refundType: Int): ServerValue {
        val value = ServerValue()
        value.setCmd(Cmd.REQUEST_CODE_51010)
        value.addParam("token", user.token)
        value.addParam("ppOrderId", ppOrderId)
        value.addParam("user_id", user.userId)
        value.addParam("userType", refundType)
        value.setDataClass(UselectExpressBean::class.java)
        return value
    }

    /**
     * 52000 优选|申请商品补发
     */
    @JvmStatic
    fun creatParam52000(user: User, ppOrderId: String, reason: String, proofImages: ArrayList<String>): ServerValue {
        val value = ServerValue()
        value.setCmd(Cmd.REQUEST_CODE_52000)
        value.addParam("token", user.token)
        value.addParam("orderId", ppOrderId)
        value.addParam("userId", user.userId)
        value.addParam("reason", reason)
        value.addParam("proofImages", proofImages)
        value.setDataClass(IsUslectReplacementBean::class.java)
        return value
    }


    /**
     * 52002 优选|商品补发详情
     */
    @JvmStatic
    fun creatParam52002(user: User, userType: Int, replacementId: String): ServerValue {
        val value = ServerValue()
        value.setCmd(Cmd.REQUEST_CODE_52002)
        value.addParam("token", user.token)
        value.addParam("userId", user.userId)
        value.addParam("userType", userType)
        value.addParam("replacementId", replacementId)
        value.setDataClass(UselectReplacementDetailBean::class.java)
        return value
    }

    /**
     * 52003 优选|申请取消商品补发
     */
    @JvmStatic
    fun creatParam52003(user: User, replacementId: String): ServerValue {
        val value = ServerValue()
        value.setCmd(Cmd.REQUEST_CODE_52003)
        value.addParam("token", user.token)
        value.addParam("user_id", user.userId)
        value.addParam("replacementId", replacementId)
        value.setDataClass(Boolean::class.java)
        return value
    }

    /**
     * 52004 优选|商品补发-确认收货
     */
    @JvmStatic
    fun creatParam52004(user: User, replacementId: String): ServerValue {
        val value = ServerValue()
        value.setCmd(Cmd.REQUEST_CODE_52004)
        value.addParam("token", user.token)
        value.addParam("user_id", user.userId)
        value.addParam("replacementId", replacementId)
        value.setDataClass(Boolean::class.java)
        return value
    }

    /**
     *  52005 优选|商品补发-获取物流信息
     */
    fun creatParam52005(user: User, replacementId: String): ServerValue {
        val value = ServerValue()
        value.setCmd(Cmd.REQUEST_CODE_52005)
        value.addParam("token", user.token)
        value.addParam("user_id", user.userId)
        value.addParam("replacementId", replacementId)
        value.setDataClass(UselectExpressBean::class.java)
        return value
    }

    /**
     *  52007 优选|用户商品补发数量
     */
    fun creatParam52007(user: User): ServerValue {
        val value = ServerValue()
        value.setCmd(Cmd.REQUEST_CODE_52007)
        value.addParam("token", user.token)
        value.addParam("user_id", user.userId)
        value.dataType = object : TypeToken<ArrayList<UselectReplacementOrderNum>>() {
        }.type
        return value
    }

    /**
     * 52001 优选|用户商品补发列表
     */
    fun creatParam52001(user: User, status: String, page: Int): ServerValue {
        val value = ServerValue()
        value.setCmd(Cmd.REQUEST_CODE_52001)
        value.addParam("token", user.token)
        value.addParam("user_id", user.userId)
        value.addParam("status", status)
        value.addParam("page", page)
        value.dataType = object : TypeToken<ArrayList<UselectReplacementListBean>>() {
        }.type
        return value
    }
}