package com.pipipifa.pilaipiwang.goodselect.presenter

import com.pipipifa.pilaipiwang.goodselect.api.UselectSevice
import com.pipipifa.pilaipiwang.model.user.User
import com.pipipifa.pilaipiwang.net.Cmd
import com.pipipifa.pilaipiwang.presenter.base.BasePresenter
import com.pipipifa.pilaipiwang.presenter.base.BaseView
import com.ppwang.ppbase.base.net.ApiURLConfig
import com.ppwang.ppbase.base.net.param.MapServerValue
import com.ppwang.ppbase.base.net.request.OkGoRequestUtil

interface UselectApplyArbitrationResultContrat {
    interface IView : BaseView {
        fun onApplyArbitrationSuccess(data: Boolean)
        fun onError()
    }

    open class Presenter(iView: IView) : BasePresenter<IView>() {
        var requestUtil: OkGoRequestUtil

        init {
            mView = iView;
            requestUtil = OkGoRequestUtil()
        }

        override fun getRequest(): OkGoRequestUtil {
            return requestUtil
        }

        fun applyArbitration(user: User, ppOrderId: String, reason: String, mSuccessImages: ArrayList<String>) {
            var value = MapServerValue()
            value.addValue(UselectSevice.creatParam51100(user, ppOrderId, reason, mSuccessImages));
            requestUtil.post(ApiURLConfig.goodsUrl(), value) { response ->
                if (response.hasError()) {
                    mView.onError()
                } else {
                    val map = response.get()
                    var data = map.get(Cmd.REQUEST_CODE_51100)
                    if (data as Boolean) {
                        mView.onApplyArbitrationSuccess(data)
                    } else {
                        mView.onError()
                    }
                }
            }
        }
    }
}