package com.pipipifa.pilaipiwang.goodselect.presenter

import com.pipipifa.pilaipiwang.AccountManager
import com.pipipifa.pilaipiwang.goodselect.api.UselectSevice
import com.pipipifa.pilaipiwang.goodselect.model.UselectArbitrationDetailBean
import com.pipipifa.pilaipiwang.net.Cmd
import com.pipipifa.pilaipiwang.presenter.base.BasePresenter
import com.pipipifa.pilaipiwang.presenter.base.BaseView
import com.ppwang.ppbase.base.net.ApiURLConfig
import com.ppwang.ppbase.base.net.param.MapServerValue
import com.ppwang.ppbase.base.net.request.OkGoRequestUtil

interface UselectArbitationDetailResultContrat {
    interface IView : BaseView {
        fun onLoadDataSuccess(bean: UselectArbitrationDetailBean)
        fun onLoadDataErrorr(errorrMessage: String)
    }

    class Presenter(iView: IView) : BasePresenter<IView>() {
        var requestUtil: OkGoRequestUtil

        init {
            mView = iView;
            requestUtil = OkGoRequestUtil()
        }

        override fun getRequest(): OkGoRequestUtil {
            return requestUtil
        }

        fun loadData(ppOrderId: String, refundType: Int) {
            var user = AccountManager.getInstance().getUser();
            if (null == user) {
                return
            }
            var value = MapServerValue()
            value.addValue(UselectSevice.creatParam51102(user, ppOrderId, refundType));
            requestUtil.post(ApiURLConfig.goodsUrl(), value) { response ->
                if (response.hasError()) {
                    mView.onLoadDataErrorr(response.errorMessage)
                } else {
                    val map = response.get()
                    var bean: UselectArbitrationDetailBean = map.get(Cmd.REQUEST_CODE_51102) as UselectArbitrationDetailBean
                    mView.onLoadDataSuccess(bean)
                }
            }
        }
    }
}