package com.pipipifa.pilaipiwang.goodselect.presenter

import com.hjq.toast.ToastUtils
import com.pipipifa.pilaipiwang.goodselect.api.UselectSevice
import com.pipipifa.pilaipiwang.goodselect.model.UselectExpressBean
import com.pipipifa.pilaipiwang.model.user.User
import com.pipipifa.pilaipiwang.net.Cmd
import com.pipipifa.pilaipiwang.presenter.base.BasePresenter
import com.pipipifa.pilaipiwang.presenter.base.BaseView
import com.ppwang.ppbase.base.net.ApiURLConfig
import com.ppwang.ppbase.base.net.param.MapServerValue
import com.ppwang.ppbase.base.net.parse.PPApi
import com.ppwang.ppbase.base.net.parse.ResponseData
import com.ppwang.ppbase.base.net.request.OkGoRequestUtil

interface UselectRefundExpressResultContrat {
    interface IView : BaseView {
        /**
         * 空状态，没有数据时调用
         */
        fun onEmptyView(msgerror: String)

        fun onLoadSuccess(bean: UselectExpressBean)
    }

    open class Presenter(iView: IView) : BasePresenter<IView>() {
        var requestUtil: OkGoRequestUtil

        init {
            mView = iView;
            requestUtil = OkGoRequestUtil()
        }

        override fun getRequest(): OkGoRequestUtil {
            return requestUtil
        }

        fun loadData(user: User, refundId: String, userType: Int) {
            var parmas = MapServerValue()
            parmas.addValue(UselectSevice.creatParam51010(user, refundId, userType))
            requestUtil.post(ApiURLConfig.goodsUrl(), parmas) { response ->

                if (response.hasError()) {
                    ToastUtils.show(response.errorMessage)
                } else {
                    var map = response.get()
                    var bean: UselectExpressBean = map.get(Cmd.REQUEST_CODE_51010) as UselectExpressBean
                    if (bean != null) {
                        mView.onLoadSuccess(bean)
                    } else {
                        mView.onEmptyView(response.errorMessage)
                    }
                }
            }
        }

        /**
         * 52005 优选|商品补发-获取物流信息
         */
        fun replacementLoad(user: User, replacementid: String) {
            var parmas = MapServerValue()
            parmas.addValue(UselectSevice.creatParam52005(user, replacementid))
            requestUtil.postRequest(ApiURLConfig.goodsUrl(), parmas, object : PPApi {
                override fun onResponse(response: ResponseData?) {
                    if (response!!.hasError()) {
                        mView.onEmptyView(response.errorMsg)
                    } else {
                        var bean = response.getData(Cmd.REQUEST_CODE_52005) as UselectExpressBean
                        mView.onLoadSuccess(bean)
                    }
                }
            })
        }
    }
}