package com.pipipifa.pilaipiwang.goodselect.presenter

import com.pipipifa.pilaipiwang.goodselect.api.UselectSevice
import com.pipipifa.pilaipiwang.goodselect.model.UselectReplacementListBean
import com.pipipifa.pilaipiwang.goodselect.model.UselectReplacementOrderNum
import com.pipipifa.pilaipiwang.model.user.User
import com.pipipifa.pilaipiwang.net.Cmd
import com.pipipifa.pilaipiwang.presenter.base.BasePresenter
import com.pipipifa.pilaipiwang.presenter.base.BaseView
import com.ppwang.ppbase.base.net.ApiURLConfig
import com.ppwang.ppbase.base.net.param.MapServerValue
import com.ppwang.ppbase.base.net.parse.PPApi
import com.ppwang.ppbase.base.net.parse.ResponseData
import com.ppwang.ppbase.base.net.request.OkGoRequestUtil

/**
 * @author: wangben
 * @date: 2020/4/25
 */
interface UselectReplacementListResultContrat {
    interface IView : BaseView {
        fun onError(errorMsg: String)
        fun onLoadSuccess(list: ArrayList<UselectReplacementOrderNum>)
        fun onReplacemertList(bean: ArrayList<UselectReplacementListBean>)
        fun onNullData()
    }

    open class Presenter(iView: IView) : BasePresenter<IView>() {
        var requestUtil: OkGoRequestUtil

        init {
            mView = iView;
            requestUtil = OkGoRequestUtil()
        }

        override fun getRequest(): OkGoRequestUtil {
            return requestUtil
        }

        /**
         * 补发补货列表
         */
        fun loadReplacemertList(user: User, status: String, page: Int) {
            var value = MapServerValue()
            value.addValue(UselectSevice.creatParam52007(user))
            value.addValue(UselectSevice.creatParam52001(user, status, page))
            requestUtil.postRequest(ApiURLConfig.goodsUrl(), value, object : PPApi {
                override fun onResponse(response: ResponseData?) {
                    if (response!!.hasError()) {
                        mView.onError(response.errorMsg)
                    } else {
                        var goodsList: ArrayList<UselectReplacementListBean>? = response.getData(Cmd.REQUEST_CODE_52001)
                        if (null != goodsList) {
                            mView.onReplacemertList(goodsList)
                        }else{
                            mView.onNullData()
                        }
                        var numList: ArrayList<UselectReplacementOrderNum>? = response.getData(Cmd.REQUEST_CODE_52007)
                        if (null != numList) {
                            mView.onLoadSuccess(numList)
                        }
                    }
                }
            })
        }
    }
}