package com.pipipifa.pilaipiwang.goodselect.presenter

import com.hjq.toast.ToastUtils
import com.pipipifa.pilaipiwang.goodselect.api.UselectSevice
import com.pipipifa.pilaipiwang.goodselect.model.UselectSelectCounierBean
import com.pipipifa.pilaipiwang.model.user.User
import com.pipipifa.pilaipiwang.net.Cmd
import com.pipipifa.pilaipiwang.presenter.base.BasePresenter
import com.pipipifa.pilaipiwang.presenter.base.BaseView
import com.ppwang.ppbase.base.net.ApiURLConfig
import com.ppwang.ppbase.base.net.param.MapServerValue
import com.ppwang.ppbase.base.net.request.OkGoRequestUtil

interface UselectSelectCounierResultContrat {
    interface IView : BaseView {
        fun onLoadDataSuccess(bean: UselectSelectCounierBean)
    }

    open class Presenter(iView: IView) : BasePresenter<IView>() {
        var requestUtil: OkGoRequestUtil

        init {
            mView = iView;
            requestUtil = OkGoRequestUtil()
        }

        override fun getRequest(): OkGoRequestUtil {
            return requestUtil
        }

        fun loadData(user: User, ppOrderId: String) {
            var value = MapServerValue()
            value.addValue(UselectSevice.creatParam51008(user, ppOrderId))
            requestUtil.post(ApiURLConfig.goodsUrl(), value) { response ->
                if (response.hasError()) {
                    ToastUtils.show(response.errorMessage)
                } else {
                    val map = response.get()
                    var data: UselectSelectCounierBean = map.get(Cmd.REQUEST_CODE_51008) as UselectSelectCounierBean
                    mView.onLoadDataSuccess(data)
                }
            }
        }
    }
}