package com.pipipifa.pilaipiwang.goodselect.ui.activity.arbitration

import android.app.Activity
import android.content.Context
import android.content.Intent
import android.os.Bundle
import android.text.Editable
import android.text.TextUtils
import android.text.TextWatcher
import android.view.View
import android.widget.EditText
import android.widget.ImageView
import android.widget.TextView
import androidx.recyclerview.widget.LinearLayoutManager
import androidx.recyclerview.widget.RecyclerView
import com.hjq.toast.ToastUtils
import com.pipipifa.pilaipiwang.AccountManager
import com.pipipifa.pilaipiwang.R
import com.pipipifa.pilaipiwang.goodselect.presenter.UselectApplyArbitrationResultContrat
import com.pipipifa.pilaipiwang.goodselect.ui.adapter.UselectAddImageAdapter
import com.pipipifa.pilaipiwang.model.upload.UploadTag
import com.pipipifa.pilaipiwang.net.StoreServerApi
import com.pipipifa.pilaipiwang.presenter.base.BaseMvpActivity
import com.pipipifa.pilaipiwang.ui.dialog.common.DefaultDialog
import com.pipipifa.pilaipiwang.util.RxUploadImage
import com.ppwang.ppbase.utils.PermissionsUtils
import com.ppwang.uikit.widget.roundwidget.PUIRoundTextView
import com.ppwang.uikit.widget.topbar.PUITopBar
import me.nereo.multi_image_selector.MultiImageSelectorActivity
import java.util.*

class UselectApplyArbitrationActivity : BaseMvpActivity<UselectApplyArbitrationResultContrat.Presenter>(), UselectApplyArbitrationResultContrat.IView {

    lateinit var mEtContent: EditText

    lateinit var mTopBar: PUITopBar

    lateinit var mIvAddImg: ImageView

    lateinit var mRecyclerView: RecyclerView

    lateinit var mTvSubmit: PUIRoundTextView

    lateinit var mTvNum: TextView

    lateinit var mTvImgNum: TextView


    var upImgArray = ArrayList<String>()
    var mSuccessImages = ArrayList<String>()
    lateinit var mImgAdapter: UselectAddImageAdapter

    var maxNum: Int = 3
    var reason = ""
    val REQUEST_CODE = 1
    var ppOrderId: String = ""

    companion object {
        var PPORDERID = "ppOrderId"
        @JvmStatic
        fun getRefundId(context: Context, ppOrderId: String?): Intent {
            val intent = Intent(context, UselectApplyArbitrationActivity::class.java)
            intent.putExtra(PPORDERID, ppOrderId)
            return intent
        }
    }

    override fun onNewIntent(intent: Intent) {
        super.onNewIntent(intent)
        initIntent(intent)
    }

    private fun initIntent(intent: Intent) {
        var getStringExtra = intent.getStringExtra(PPORDERID)
        if (null != getStringExtra) {
            ppOrderId = intent.getStringExtra(PPORDERID)
        }
    }

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_uselect_apply_arbitration)
        initIntent(intent)
        initView()
        initTopBar()
        mPresenter = UselectApplyArbitrationResultContrat.Presenter(this)
    }

    private fun initTopBar() {
        mTopBar.setTitle("申请仲裁")
    }

    private fun initView() {
        mEtContent = findViewById(R.id.et_arbitration_apply_content)
        mTopBar = findViewById(R.id.topbar_apply_arbitration)
        mIvAddImg = findViewById(R.id.iv_arbitration_apply_add_img)
        mRecyclerView = findViewById(R.id.rv_arbitration_apply)
        mTvSubmit = findViewById(R.id.tv_arbitration_apply_submit)
        mTvNum = findViewById(R.id.tv_arbitration_apply_textnum)
        mTvImgNum = findViewById(R.id.tv_img_num)

        val linearLayoutManager = LinearLayoutManager(this, LinearLayoutManager.HORIZONTAL, false)
        mRecyclerView.layoutManager = linearLayoutManager
        mImgAdapter = UselectAddImageAdapter()
        mRecyclerView.adapter = mImgAdapter

        mImgAdapter.onDeteleImgClickLister(object : UselectAddImageAdapter.onDeteleImgClickLister {
            override fun deteleImg(img: String) {
                mImgAdapter.data.remove(img)
                mImgAdapter.notifyDataSetChanged()
            }
        })

        mEtContent.addTextChangedListener(object : TextWatcher {
            override fun afterTextChanged(s: Editable?) {

            }

            override fun beforeTextChanged(s: CharSequence?, start: Int, count: Int, after: Int) {

            }

            override fun onTextChanged(s: CharSequence?, start: Int, before: Int, count: Int) {
                if (s!!.toString().length > 255) {
                    ToastUtils.show("您输入的字数超过255个")
                } else {
                    mTvNum.text = s.length.toString() + "/255"
                }
            }
        })

        mIvAddImg.setOnClickListener {
            if (mImgAdapter.data.size >= maxNum) {
                ToastUtils.show(String.format("最多只能上传%s张", maxNum))
                return@setOnClickListener
            }
            checkPermissions()
        }

        mTvSubmit.setOnClickListener {
            reason = mEtContent.text.toString()
            if (reason.length < maxNum) {
                ToastUtils.show("请输入说明理由，支持1至255个字符")
                return@setOnClickListener
            }

            if (mImgAdapter.data.size == 0) {
                ToastUtils.show("请选择申请凭证，至少1至3张")
                return@setOnClickListener
            }

            var dialog = DefaultDialog(this as Context)
            dialog.setTitle("提示")
            dialog.setMessage("是否确定执行此操作？")
            dialog.setOkButton("确定", View.OnClickListener {
                dialog.cancel()
                showLoadingDialog("正在提交...", false, false)
                upFildImg(mImgAdapter.data)
            })
            dialog.setCancelButton("取消", View.OnClickListener { dialog.cancel() })
            dialog.show()
        }
    }

    fun checkPermissions() {
        PermissionsUtils.requestCameraPermissions(this) { addPictrue() }
    }

    private fun addPictrue() {
        val intent = Intent(this, MultiImageSelectorActivity::class.java)
        // 是否显示调用相机拍照
        intent.putExtra(MultiImageSelectorActivity.EXTRA_SHOW_CAMERA, true)
        // 最大图片选择数量
        intent.putExtra(MultiImageSelectorActivity.EXTRA_SELECT_COUNT, maxNum)
        intent.putExtra(MultiImageSelectorActivity.EXTRA_SELECT_MODE, MultiImageSelectorActivity.MODE_MULTI)
        // 默认选择
        if (upImgArray != null && upImgArray.size != 0) {
            intent.putExtra(MultiImageSelectorActivity.EXTRA_DEFAULT_SELECTED_LIST, upImgArray)
        }
        startActivityForResult(intent, REQUEST_CODE_GOOD_IMAGE)
    }

    var REQUEST_CODE_GOOD_IMAGE = 1
    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        if (resultCode == Activity.RESULT_OK) {
            if (requestCode == REQUEST_CODE_GOOD_IMAGE) {
                val selectImages = data!!.getStringArrayListExtra(MultiImageSelectorActivity.EXTRA_RESULT)
                if (selectImages != null && selectImages.size > 0) {
                    mSuccessImages.clear()
                    mImgAdapter.setNewData(selectImages)
                }
            }
        }
    }

    private fun upFildImg(data: List<String>) {
        val uploadTags = ArrayList<UploadTag>()

        showLoadingDialog("正在上传，请稍候...", false, false)
        for (i in data.indices) {
            uploadTags.add(UploadTag(i.toString(), data.get(i)))
        }

        val uploadImage = RxUploadImage(this, uploadTags, StoreServerApi.FOLDER_TYPE_ORDER)
        uploadImage.setListener(object : RxUploadImage.UploadImageListener {
            override fun onSuccess(success: Int, tag: UploadTag) {
                mSuccessImages.add(tag.bucket)
            }

            override fun onError(e: Throwable) {
                dismissLoadingDialog()
            }

            override fun onComplete() {
                dismissLoadingDialog()
                if (null != mPresenter) {
                    var user = AccountManager.getInstance().getUser()
                    if (null != user) {
                        mPresenter.applyArbitration(user, ppOrderId, reason, mSuccessImages)
                    }
                }
            }
        })
        uploadImage.startUpload(AccountManager.getInstance().user)
    }

    override fun onApplyArbitrationSuccess(data: Boolean) {
        if (data) {
            if (!TextUtils.isEmpty(ppOrderId)){
                startActivity(Intent(UselectArbitationDetailActivity.getArbitrationId(this, ppOrderId, 0)))
            }
        }
    }

    override fun onError() {

    }

}