package com.pipipifa.pilaipiwang.goodselect.ui.activity.arbitration

import android.content.Context
import android.content.Intent
import android.os.Bundle
import android.os.Handler
import android.os.Looper
import android.widget.TextView
import androidx.core.content.ContextCompat
import androidx.recyclerview.widget.LinearLayoutManager
import androidx.recyclerview.widget.RecyclerView
import com.hjq.toast.ToastUtils
import com.ppwang.uikit.widget.roundwidget.PUIRoundTextView
import com.pipipifa.pilaipiwang.R
import com.pipipifa.pilaipiwang.goodselect.model.UselectArbitrationDetailBean
import com.pipipifa.pilaipiwang.goodselect.model.UselectProofListBean
import com.pipipifa.pilaipiwang.goodselect.presenter.UselectArbitationDetailResultContrat
import com.pipipifa.pilaipiwang.goodselect.ui.adapter.UselectArbitrationCellAdapter
import com.pipipifa.pilaipiwang.presenter.base.BaseMvpActivity
import com.pipipifa.util.DateUtils
import com.pipipifa.util.StringUtil
import java.util.*
import kotlin.collections.ArrayList

class UselectArbitationDetailActivity : BaseMvpActivity<UselectArbitationDetailResultContrat.Presenter>(), UselectArbitationDetailResultContrat.IView {
    var identiyType = 0
    var ppOrderId = ""

    lateinit var mRecyclerView: RecyclerView
    lateinit var mTvOrdernum: TextView
    lateinit var mTvBuyerName: TextView
    lateinit var mTvSellerName: TextView
    lateinit var mTvTime: TextView
    lateinit var mButCommit: PUIRoundTextView

    lateinit var mAdapter: UselectArbitrationCellAdapter
    var proofArray: ArrayList<UselectProofListBean> = ArrayList()

    val timer = Timer()

    companion object {
        var ARBITRATIONID = "ppOrderId"
        var IDENTIYTYPE = "identiytype"
        @JvmStatic
        fun getArbitrationId(context: Context, arbitrationId: String?, identiyType: Int): Intent {
            val intent = Intent(context, UselectArbitationDetailActivity::class.java)
            intent.putExtra(ARBITRATIONID, arbitrationId)
            intent.putExtra(IDENTIYTYPE, identiyType)
            return intent
        }
    }


    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_uselect_arbitation_detail)
        initIntent(intent)
        initView()
        isFastDouble()
        mPresenter = UselectArbitationDetailResultContrat.Presenter(this)
    }

    fun isFastDouble() {
        showLoadingDialog("正在同步数据...", true, false)
        timer.schedule(object : TimerTask() {

            override fun run() {
                Handler(Looper.getMainLooper()).post {
                    dismissLoadingDialog()
                    if (null != mPresenter) {
                        mPresenter.loadData(ppOrderId, identiyType)
                    }
                }
            }
        }, 3000)
    }

    override fun onDestroy() {
        super.onDestroy()
        if (timer != null) {
            timer.cancel()
            timer == null
        }
    }

    private fun initIntent(intent: Intent) {
        var getStringExtra = intent.getStringExtra(ARBITRATIONID)
        if (null != getStringExtra) {
            ppOrderId = intent.getStringExtra(ARBITRATIONID)
        }

        var getIntExtra = intent.getIntExtra(IDENTIYTYPE, 0)
        if (null != getIntExtra) {
            identiyType = intent.getIntExtra(IDENTIYTYPE, 0)
        }
    }


    private fun initView() {
        mRecyclerView = findViewById(R.id.recyclerview)
        mTvOrdernum = findViewById(R.id.tv_arbitration_detail_ordernum)
        mTvBuyerName = findViewById(R.id.tv_arbitration_detail_buyer)
        mTvSellerName = findViewById(R.id.tv_arbitration_detail_seller)
        mTvTime = findViewById(R.id.tv_arbitration_detail_time)
        mButCommit = findViewById(R.id.pui_refund_commit)


        mAdapter = UselectArbitrationCellAdapter()
        mRecyclerView.layoutManager = LinearLayoutManager(this)
        mRecyclerView.adapter = mAdapter
    }


    override fun onLoadDataSuccess(bean: UselectArbitrationDetailBean) {
        if (null != bean) {
            bindBean(bean)
        }
    }

    override fun onLoadDataErrorr(errorrMessage: String) {
        dismissLoadingDialog()
        ToastUtils.show(errorrMessage)
    }

    fun bindBean(data: UselectArbitrationDetailBean?) {
        mTvOrdernum.setText(data?.orderNo)
        if (data!!.startUserType.equals("1")) {
            var name = StringUtil.formatColor(String.format("%s[(申请人)]", data?.userName),
                    ContextCompat.getColor(this, R.color.color_FF682F))
            mTvBuyerName.setText(name)
            mTvSellerName.setText(data?.mchName)
        } else {
            var name = StringUtil.formatColor(String.format("%s[(申请人)]", data?.mchName),
                    ContextCompat.getColor(this, R.color.color_FF682F))
            mTvSellerName.setText(name)
            mTvBuyerName.setText(data?.userName)
        }
        mTvTime.setText(DateUtils.dateToString(Date(data?.addTime!! * 1000), DateUtils.FORMAT_STRING_DATE_TIME))

        if (null != data && data!!.proofList.size > 0) {
            proofArray = data.proofList
            BindData(data)
        }
    }

    private fun BindData(data: UselectArbitrationDetailBean?) {
        for (i in data!!.proofList) {
            if (i.userType == 1) {
                i.name = data.userName
            } else if (i.userType == 2) {
                i.name = data.mchName
            }
        }
        mAdapter.setNewData(proofArray)
    }
}