package com.pipipifa.pilaipiwang.goodselect.ui.activity.refund

import android.annotation.SuppressLint
import android.app.Activity
import android.content.Context
import android.content.Intent
import android.os.Bundle
import android.text.Editable
import android.text.TextWatcher
import android.view.MotionEvent
import android.view.View
import android.widget.*
import androidx.core.content.ContextCompat
import androidx.recyclerview.widget.LinearLayoutManager
import androidx.recyclerview.widget.RecyclerView
import com.hjq.toast.ToastUtils
import com.pipipifa.pilaipiwang.AccountManager
import com.pipipifa.pilaipiwang.R
import com.pipipifa.pilaipiwang.goodselect.model.*
import com.pipipifa.pilaipiwang.goodselect.presenter.UselectApplyRefundResultContrat
import com.pipipifa.pilaipiwang.goodselect.ui.adapter.UselectAddImageAdapter
import com.pipipifa.pilaipiwang.goodselect.ui.adapter.UselectApplyRefundAdapter
import com.pipipifa.pilaipiwang.goodselect.ui.dialog.UselectBaseTextDialog
import com.pipipifa.pilaipiwang.model.upload.UploadTag
import com.pipipifa.pilaipiwang.net.StoreServerApi
import com.pipipifa.pilaipiwang.presenter.base.BaseMvpActivity
import com.pipipifa.pilaipiwang.ui.dialog.common.DefaultDialog
import com.pipipifa.pilaipiwang.util.RxUploadImage
import com.ppwang.ppbase.base.net.request.OkGoRequestUtil
import com.ppwang.ppbase.utils.ArrayUtil
import com.ppwang.ppbase.utils.ButtonClickUtils
import com.ppwang.ppbase.utils.PermissionsUtils
import com.ppwang.uikit.widget.roundwidget.PUIRoundTextView
import com.ppwang.uikit.widget.topbar.PUITopBar
import me.nereo.multi_image_selector.MultiImageSelectorActivity
import java.util.*
import kotlin.collections.ArrayList

class UselectApplyRefundActivity : BaseMvpActivity<UselectApplyRefundResultContrat.Presenter>(), UselectApplyRefundResultContrat.IView {
    var applyRefundType = 0
    val REQUEST_CODE = 1
    var REQUEST_CODE_GOOD_IMAGE = 2
    var REQUEST_CODE_ADAPTER_IMAGE = 3

    /**
     *  凭证分为三种格式
    全单退，7天无理由(退货退款理由的proofType=1)，使用格式一
    全单退，瑕疵品 （退货退款理由的proofType=2），使用格式二
    部分退，7天无理由（退货退款理由的proofType=1），使用格式三
    部分退，瑕疵品（退货退款理由的proofType=2），使用格式二
     */
    var APPLY_REFUND_TYOE01 = 4 //使用格式一
    var APPLY_REFUND_TYOE02 = 5 //使用格式二
    var APPLY_REFUND_TYOE03 = 6 //使用格式三
    var APPLY_REFUND_TYOE04 = 7 //补发补货的申请状态

    var identiyType = 0
    var refundType = 0
    var ppOrderId = ""
    var skuType = true
    //部分商品价格
    var price = 0f
    //全部商品价格
    var mQuanPrice = ""
    var imgType = false
    var goods: UselectGoodsBean? = null

    lateinit var mTopBar: PUITopBar
    lateinit var mRightText: TextView
    lateinit var mRecyclerView: RecyclerView
    lateinit var mTvCommint: PUIRoundTextView
    lateinit var mAdapter: UselectApplyRefundAdapter
    /**
     * 头部属性
     */
    lateinit var mHeaderView: View
    lateinit var mTvAllSingle: TextView
    lateinit var mTvpart: TextView
    lateinit var mTvReplacement: TextView
    lateinit var mEtReason: EditText
    lateinit var mTvPrice: TextView
    lateinit var mTvWhy: TextView
    lateinit var mTvTextNum: TextView
    lateinit var mLlPrice: LinearLayout
    lateinit var mLlWhy: LinearLayout
    lateinit var mLlReplacement: LinearLayout

    var refundReasonTypeId: String? = ""// 退款理由选择的ID
    var reason: String? = ""//退款理由text
    var reasonType = ""
    var orderType = false//订单传过来的状态如果是代发货隐藏补发
    /**
     * 尾部添加图片
     */
    lateinit var mFooterView: View
    lateinit var mRlAddImg: RelativeLayout
    lateinit var mIvAddImg: ImageView
    lateinit var mTvImgNum: TextView
    lateinit var mImgRecyclerView: RecyclerView
    lateinit var mImgAdapter: UselectAddImageAdapter
    lateinit var mDialog: UselectBaseTextDialog

    // 不需要商品信息时候的图片上传
    var maxNum = 5
    //选择的图片
    var mImgList: ArrayList<String> = ArrayList()
    //上传成功的图片
    var mSuccessImages: ArrayList<String> = ArrayList()
    var goodsSelectList: ArrayList<UselectGoodsBean> = ArrayList()
    var mapGoodsImgs = HashMap<String, ArrayList<String>>();
    var mUpGoodsList: ArrayList<UselectUpGoosBean> = ArrayList()
    var mSelectGoodsList: ArrayList<UselectGoodsBean> = ArrayList()

    var okhttp: OkGoRequestUtil = OkGoRequestUtil()

    companion object {
        var GOODS = "goods"
        var PPORDERID = "ppOrderId"
        var IDENTITYTYPE = "identityType"
        var ORDERTYPE = "ordertype"
        @JvmStatic
        fun getGoods(context: Context, goods: UselectGoodsBean?): Intent {
            val intent = Intent(context, UselectApplyRefundActivity::class.java)
            intent.putExtra(GOODS, goods)
            return intent
        }

        @JvmStatic
        fun getppOrderId(context: Context, ppOrderId: String?, identityType: Int): Intent {
            val intent = Intent(context, UselectApplyRefundActivity::class.java)
            intent.putExtra(PPORDERID, ppOrderId)
            intent.putExtra(IDENTITYTYPE, identityType)
            return intent
        }

        @JvmStatic
        fun getppOrderId(context: Context, ppOrderId: String?, identityType: Int, orderType: Boolean): Intent {
            val intent = Intent(context, UselectApplyRefundActivity::class.java)
            intent.putExtra(PPORDERID, ppOrderId)
            intent.putExtra(IDENTITYTYPE, identityType)
            intent.putExtra(ORDERTYPE, orderType)
            return intent
        }
    }

    override fun onNewIntent(intent: Intent) {
        super.onNewIntent(intent)
        initIntent(intent)
    }

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_uselect_apply_refund)
        initIntent(intent)
        initView()
        initBar()
        mPresenter = UselectApplyRefundResultContrat.Presenter(this)
        if (skuType) {
            if (null != mPresenter) {
                var user = AccountManager.getInstance().getUser();
                if (null != user) {
                    mPresenter.loadGoodsData(user, ppOrderId)
                }
            }
        }
    }

    override fun onResume() {
        super.onResume()
        if (null != goods) {
            skuType = false
            for (item in mSelectGoodsList) {
                if (item.goodsId == goods!!.goodsId) {
                    mSelectGoodsList.remove(item)
                }
            }
            if (applyRefundType == APPLY_REFUND_TYOE02) {
                mAdapter.LinearLayoutVisibility(false)
            } else {
                mAdapter.LinearLayoutVisibility(true)
            }
            //设置返回后的sku显示
            setGoodSku()
            mAdapter.data.add(goods!!)
            mAdapter.addImgVisibility(false)
            mAdapter.notifyDataSetChanged()
        }
        //每次添加完成以后就设置为空值防止重复添加
        goods = null
    }

    private fun setGoodSku() {
        var size = 0
        price = 0f
        val mStringBuilder = StringBuilder();
        for (i in goods!!.attr!!) {
            if (i.num != 0) {
                size = size + i.num!!
                mStringBuilder.append(String.format("%s*%s(编号:%s)", i.specName, i.num, i.specNo)).append(",")
            }
        }
        price += ((goods!!.payPrice.toFloatOrNull() ?: 0f) * size)
        var skuText = ""
        if (mStringBuilder.length > 0) {
            skuText = mStringBuilder.substring(0, mStringBuilder.length - 1);
        } else {
            skuText = mStringBuilder.toString();
        }
        goods!!.size = size
        goods!!.skuDetail = skuText
        mTvPrice.setText(String.format("%.2f", price))
    }

    private fun initBar() {
        mTopBar = findViewById(R.id.top_bar_apply_refund)
        if (orderType) {
            mTopBar.setTitle("申请退款")
        } else {
            mTopBar.setTitle("退款/补发")
        }
        mRightText = mTopBar.addRightTextView("选择商品")
        mRightText.visibility = View.GONE
        mRightText.setTextColor(ContextCompat.getColor(this, R.color.text_color_FF682F))
        mRightText.setOnClickListener {
            startActivity(UselectSelectGoodsActivity.getGoods(this, mSelectGoodsList))
        }
    }

    @SuppressLint("WrongConstant")
    private fun initView() {
        mRecyclerView = findViewById(R.id.rv_apply_refund)
        mTvCommint = findViewById(R.id.pui_apply_refund_commit)
        mAdapter = UselectApplyRefundAdapter()

        initHeaderView()
        initFooderView()
        mAdapter.addHeaderView(mHeaderView)
        mAdapter.addFooterView(mFooterView)

        val manager = LinearLayoutManager(this, LinearLayoutManager.VERTICAL, false)
        mRecyclerView.layoutManager = manager
        mRecyclerView.adapter = mAdapter
        setAdapterOnclickList()

        mTvCommint.setOnClickListener {
            if (refundType == 3) {
                reason = mEtReason.text.toString()
                if (reason!!.length < 5) {
                    dismissLoadingDialog()
                    ToastUtils.show("必填，请如实告知需要补发的商品、补发数量并说明补发理由，支持5至255个字符")
                    return@setOnClickListener
                }
            } else {
                if (refundType == 0) {
                    dismissLoadingDialog()
                    if (orderType) {
                        ToastUtils.show("请选择全单退或部分退货")
                    } else {
                        ToastUtils.show("请选择退款/补发类型")
                    }
                    return@setOnClickListener
                }

                if (refundReasonTypeId!!.isBlank()) {
                    dismissLoadingDialog()
                    ToastUtils.show("请选择退款原因")
                    return@setOnClickListener
                }

                reason = mEtReason.text.toString()
                if (reason!!.length < 5) {
                    dismissLoadingDialog()
                    ToastUtils.show("请输入说明理由，支持5至255个字符")
                    return@setOnClickListener
                }
            }

            var dialog = DefaultDialog(this as Context)
            dialog.setTitle("提示")
            dialog.setMessage("是否确定执行此操作？")
            dialog.setOkButton("确定", View.OnClickListener {
                dialog.cancel()
                showLoadingDialog("确定", false, false)
                commintRefund()
            })
            dialog.setCancelButton("取消", View.OnClickListener { dialog.cancel() })
            dialog.show()
        }
    }

    private fun setAdapterOnclickList() {
        mAdapter.OnGoodsItemClickLister(object : UselectApplyRefundAdapter.OnGoodsItemClickLister {
            override fun addItemImg(goodsSize: Int, images: ArrayList<String>) {
                mAdapter.deteleImageList(false)
                addAdapterPictrue(goodsSize, images)
            }

            override fun deteleItem(goods: UselectGoodsBean?) {
                mSelectGoodsList.add(goods!!)
                mAdapter.deteleImageList(true)
                mAdapter.data.remove(goods)
                mAdapter.notifyDataSetChanged()
            }
        })
    }


    private fun initIntent(intent: Intent) {
        var getSerializableExtra = intent.getSerializableExtra(GOODS)
        if (null != getSerializableExtra) {
            goods = intent.getSerializableExtra(GOODS) as UselectGoodsBean
        }

        var getStringExtra = intent.getStringExtra(PPORDERID)
        if (null != getStringExtra) {
            ppOrderId = intent.getStringExtra(PPORDERID)
        }

        var getIntExtra = intent.getIntExtra(IDENTITYTYPE, 0)
        if (null != getIntExtra) {
            identiyType = intent.getIntExtra(IDENTITYTYPE, 0)
        }

        var getBooleExtra = intent.getBooleanExtra(ORDERTYPE, false)
        if (null != getBooleExtra) {
            orderType = intent.getBooleanExtra(ORDERTYPE, false)
        }
    }

    @SuppressLint("ClickableViewAccessibility")
    fun initHeaderView() {
        mHeaderView = LinearLayout.inflate(this, R.layout.uselect_apply_refund_header_layout, null)

        mTvAllSingle = mHeaderView.findViewById(R.id.tv_apply_refund_header_allsingle)
        mTvpart = mHeaderView.findViewById(R.id.tv_apply_refund_header_part)
        mTvReplacement = mHeaderView.findViewById(R.id.tv_apply_refund_header_replacement)
        mEtReason = mHeaderView.findViewById(R.id.et_apply_refund_header_reason)
        mTvPrice = mHeaderView.findViewById(R.id.tv_apply_refund_header_price)
        mTvWhy = mHeaderView.findViewById(R.id.tv_apply_refund_header_why)
        mTvTextNum = mHeaderView.findViewById(R.id.tv_refund_header_textnum)
        mLlPrice = mHeaderView.findViewById(R.id.ll_header_price)
        mLlWhy = mHeaderView.findViewById(R.id.ll_header_why)
        mLlReplacement = mHeaderView.findViewById(R.id.ll_header_replacement)

        if (orderType) {
            mTvReplacement.visibility = View.GONE
        } else {
            mTvReplacement.visibility = View.VISIBLE
        }

        mEtReason.setOnTouchListener(object : View.OnTouchListener {
            override fun onTouch(v: View?, event: MotionEvent?): Boolean {
                v!!.getParent().requestDisallowInterceptTouchEvent(true);
                return false;
            }
        })

        mEtReason.addTextChangedListener(object : TextWatcher {
            override fun afterTextChanged(s: Editable?) {

            }

            override fun beforeTextChanged(s: CharSequence?, start: Int, count: Int, after: Int) {

            }

            override fun onTextChanged(s: CharSequence?, start: Int, before: Int, count: Int) {
                if (s!!.toString().length > 255) {
                    ToastUtils.show("您输入的字数超过255个")
                } else {
                    mTvTextNum.setText(String.format("%s/255", s.length))
                }
            }
        })
        setRefundClick()
    }

    private fun initFooderView() {
        mFooterView = LinearLayout.inflate(this, R.layout.uselect_apply_refund_fooder_layout, null)
        mRlAddImg = mFooterView.findViewById(R.id.rl_refund_header_addImg)
        mTvImgNum = mFooterView.findViewById(R.id.tv_refund_header_imgNum)
        mIvAddImg = mFooterView.findViewById(R.id.iv_refund_header_add_img)
        mImgRecyclerView = mFooterView.findViewById(R.id.rv_refund_header_imglist)

        val linearLayoutManager = LinearLayoutManager(this, LinearLayoutManager.HORIZONTAL, false)
        mImgRecyclerView.layoutManager = linearLayoutManager
        mImgAdapter = UselectAddImageAdapter()
        mImgRecyclerView.adapter = mImgAdapter
        mImgAdapter.onDeteleImgClickLister(object : UselectAddImageAdapter.onDeteleImgClickLister {
            override fun deteleImg(img: String) {
                mImgList.remove(img)
                mImgAdapter.data.remove(img)
                mImgAdapter.notifyDataSetChanged()
                mTvImgNum.text = String.format("%s/5", mImgList.size)
            }
        })

        mIvAddImg.setOnClickListener {
            if (mImgList.size >= 5) {
                ToastUtils.show("最多可以选择5张图片")
                return@setOnClickListener
            }
            checkPermissions()
        }
    }


    /**
     * 头部的点击事件
     */
    private fun setRefundClick() {
        mTvAllSingle.setOnClickListener {
            refundType = 1
            setUpGoodsType(refundType, reasonType)
        }

        mTvpart.setOnClickListener {
            refundType = 2
            setUpGoodsType(refundType, reasonType)
        }

        mTvReplacement.setOnClickListener {
            refundType = 3
            setUpGoodsType(refundType, "0")
        }

        mTvWhy.setOnClickListener {
            if (ButtonClickUtils.isFastDoubleClick()) {
                mDialog = UselectBaseTextDialog(this)
                mDialog.setTitleText("退款理由").show()
                if (null != mPresenter) {
                    mPresenter.loadDialogData()
                }
            }
        }
    }

    fun setDialog(bean: UselectRefundReasonBean) {
        for (item in bean.list) {
            var bean = UselectBaseDialogBean()
            bean.id = item.id.toString()
            bean.title = item.content.toString()
            bean.type = item.proofType.toString()
            mDialog.addBaseBeanData(bean)
        }
        mDialog.setOnTitleClickListener(object : UselectBaseTextDialog.OnTitleClickListener {
            override fun onClick(id: String, title: String, type: String) {
                mTvWhy.setText(title)
                refundReasonTypeId = id
                reason = title
                reasonType = type
                setUpGoodsType(refundType, reasonType)
                mAdapter.notifyDataSetChanged()
                mDialog.dismiss()
            }
        })
    }

    fun setUpGoodsType(refundType: Int, type: String) {
        when (refundType) {
            1 -> {
                mTvAllSingle.setTextColor(ContextCompat.getColor(this, R.color.white))
                mTvpart.setTextColor(ContextCompat.getColor(this, R.color.text_color_FF682F))
                mTvReplacement.setTextColor(ContextCompat.getColor(this, R.color.text_color_FF682F))
                mTvAllSingle.isEnabled = false
                mTvpart.isEnabled = true
                mTvReplacement.isEnabled = true
                mRightText.visibility = View.GONE
                mLlReplacement.visibility = View.GONE
                mLlPrice.visibility = View.VISIBLE
                mLlWhy.visibility = View.VISIBLE
                mEtReason.hint = "详细说明好让商家清楚你的情况，支持5~255个字符"
                // 清空缓存的图片
                mAdapter.deteleImageList(true)
                mAdapter.setNewData(null)
                if (mQuanPrice.isNotBlank()) {
                    mTvPrice.text = String.format("%s", mQuanPrice)
                }
                if (type == "2") {
                    applyRefundType = APPLY_REFUND_TYOE02
                    mRlAddImg.visibility = View.GONE
                    if (refundType == 1) {
                        addGoodsData()
                    }
                } else {
                    applyRefundType = APPLY_REFUND_TYOE01
                    mRlAddImg.visibility = View.VISIBLE
                    mAdapter.setNewData(null)
                }
                mRightText.visibility = View.GONE
            }
            2 -> {
                mTvpart.setTextColor(ContextCompat.getColor(this, R.color.white))
                mTvAllSingle.setTextColor(ContextCompat.getColor(this, R.color.text_color_FF682F))
                mTvReplacement.setTextColor(ContextCompat.getColor(this, R.color.text_color_FF682F))
                mLlReplacement.visibility = View.GONE
                mLlPrice.visibility = View.VISIBLE
                mLlWhy.visibility = View.VISIBLE
                mTvpart.isEnabled = false
                mTvAllSingle.isEnabled = true
                mTvReplacement.isEnabled = true
                mEtReason.hint = "详细说明好让商家清楚你的情况，支持5~255个字符"
                if (applyRefundType != 0) {
                    mRightText.visibility = View.VISIBLE
                }
                mAdapter.deteleImageList(true)
                mAdapter.setNewData(null)
                if (refundReasonTypeId!!.isNotBlank()) {
                    mRightText.visibility = View.VISIBLE
                    if (null != mSelectGoodsList) {
                        mSelectGoodsList.clear()
                        mSelectGoodsList.addAll(goodsSelectList)
                    }
                }
                if (type == "2") {
                    applyRefundType = APPLY_REFUND_TYOE02
                    mRlAddImg.visibility = View.GONE
                    mAdapter.LinearLayoutVisibility(false)
                } else {
                    applyRefundType = APPLY_REFUND_TYOE03
                    mRlAddImg.visibility = View.VISIBLE
                    mAdapter.LinearLayoutVisibility(true)
                }
                if (refundType != 0) {
                    mRightText.visibility = View.VISIBLE
                } else {
                    mRightText.visibility = View.GONE
                }
            }
            3 -> {
                mTvReplacement.setTextColor(ContextCompat.getColor(this, R.color.white))
                mTvpart.setTextColor(ContextCompat.getColor(this, R.color.text_color_FF682F))
                mTvAllSingle.setTextColor(ContextCompat.getColor(this, R.color.text_color_FF682F))
                mTvReplacement.isEnabled = false
                mTvpart.isEnabled = true
                mTvAllSingle.isEnabled = true
                mRightText.visibility = View.GONE
                mRlAddImg.visibility = View.VISIBLE
                mLlPrice.visibility = View.GONE
                mLlWhy.visibility = View.GONE
                mLlReplacement.visibility = View.VISIBLE
                applyRefundType = APPLY_REFUND_TYOE04
                mEtReason.hint = "必填，请如实告知需要补发的商品、补发数量并说明补发理由，支持5至255个字符"
                // 清空缓存的图片
                mAdapter.deteleImageList(true)
                mAdapter.LinearLayoutVisibility(true)
                mAdapter.setNewData(null)
            }
        }
    }

    private fun commintRefund() {
        when (applyRefundType) {
            APPLY_REFUND_TYOE01, APPLY_REFUND_TYOE04 -> {
                if (ArrayUtil.isEmpty(mImgList)) {
                    dismissLoadingDialog()
                    ToastUtils.show("请输入上传凭证，至少1至5张")
                    return
                } else {
                    showLoadingDialog("正在提交...", true, false)
                    mSuccessImages.clear()
                    upFildImg(mImgList)
                }
            }
            APPLY_REFUND_TYOE02 -> {
                if (mAdapter.data.size > 0) {
                    showLoadingDialog("正在提交...", true, false)
                    for (item in mAdapter.data) {
                        if (ArrayUtil.isEmpty(mAdapter.mImgageList)) {
                            dismissLoadingDialog()
                            ToastUtils.show("请输入上传凭证")
                            return
                        }
                        if (refundType == 1) {
                            var goodsSize = 0
                            if (item!!.attr!!.size > 0) {
                                for (i in item.attr!!) {
                                    goodsSize += i.refundableNum ?: 0
                                }
                            }
                            item.size = goodsSize
                            if (goodsSize == item.images.size) {
                                upAdapterFildImg(item.goodsId, item.attr, item.images)
                            } else {
                                dismissLoadingDialog()
                                ToastUtils.show("输入的上传凭证数量和退款数必须一样")
                            }
                        } else {
                            if (item.size == item.images.size) {
                                showLoadingDialog("正在提交...", true, false)
                                upAdapterFildImg(item.goodsId, item.attr, item.images)
                                continue
                            } else {
                                dismissLoadingDialog()
                                ToastUtils.show("输入的上传凭证数量和退款数必须一样")
                            }
                        }
                    }
                } else {
                    dismissLoadingDialog()
                    ToastUtils.show("请选择退款商品")
                }
            }
            APPLY_REFUND_TYOE03 -> {
                if (mAdapter.data.size > 0) {
                    if (ArrayUtil.isEmpty(mImgList)) {
                        dismissLoadingDialog()
                        ToastUtils.show("请输入上传凭证，至少1至5张")
                        return
                    } else {
                        showLoadingDialog("正在提交...", true, false)
                        imgType = true
                        mSuccessImages.clear()
                        upFildImg(mImgList)
                    }
                } else {
                    dismissLoadingDialog()
                    ToastUtils.show("请选择退款商品")
                }
            }
        }
    }

    private fun checkPermissions() {
        PermissionsUtils.requestCameraPermissions(this) { addPictrue() }
    }


    private fun addPictrue() {
        val intent = Intent(this, MultiImageSelectorActivity::class.java)
        // 是否显示调用相机拍照
        intent.putExtra(MultiImageSelectorActivity.EXTRA_SHOW_CAMERA, true)
        // 最大图片选择数量
        intent.putExtra(MultiImageSelectorActivity.EXTRA_SELECT_COUNT, maxNum)
        intent.putExtra(MultiImageSelectorActivity.EXTRA_SELECT_MODE, MultiImageSelectorActivity.MODE_MULTI)
        // 默认选择
        if (mImgList != null && mImgList.size != 0) {
            intent.putExtra(MultiImageSelectorActivity.EXTRA_DEFAULT_SELECTED_LIST, mImgList)
        }
        startActivityForResult(intent, REQUEST_CODE_GOOD_IMAGE)
    }


    private fun addAdapterPictrue(maxCount: Int, images: ArrayList<String>?) {
        val intent = Intent(this, MultiImageSelectorActivity::class.java)
        // 是否显示调用相机拍照
        intent.putExtra(MultiImageSelectorActivity.EXTRA_SHOW_CAMERA, true)
        // 最大图片选择数量
        intent.putExtra(MultiImageSelectorActivity.EXTRA_SELECT_COUNT, maxCount)
        intent.putExtra(MultiImageSelectorActivity.EXTRA_SELECT_MODE, MultiImageSelectorActivity.MODE_MULTI)
        // 默认选择
        if (images != null && images.size != 0) {
            intent.putExtra(MultiImageSelectorActivity.EXTRA_DEFAULT_SELECTED_LIST, images)
        }
        startActivityForResult(intent, REQUEST_CODE_ADAPTER_IMAGE)
    }


    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        if (resultCode == Activity.RESULT_OK) {
            when (requestCode) {
                REQUEST_CODE_GOOD_IMAGE -> {
                    val selectImages = data!!.getStringArrayListExtra(MultiImageSelectorActivity.EXTRA_RESULT)
                    if (selectImages != null && selectImages.size > 0) {
                        mImgList.clear()
                        mSuccessImages.clear()
                        mImgAdapter.data.clear()
                        for (i in selectImages) {
                            if (mImgList.contains(i)) {
                                mImgList.remove(i)
                            }
                        }
                        mImgList.addAll(selectImages)
                        mImgAdapter.addData(mImgList)
                        mImgAdapter.notifyDataSetChanged()
                        mTvImgNum.text = String.format("%s/5", mImgList.size)
                    }
                }
                REQUEST_CODE_ADAPTER_IMAGE -> {
                    val selectImages = data!!.getStringArrayListExtra(MultiImageSelectorActivity.EXTRA_RESULT)
                    if (selectImages != null && selectImages.size > 0) {
                        mAdapter.addImageList(selectImages)
                        mAdapter.notifyDataSetChanged()
                    }
                }
            }
        }
    }


    //第一种上传
    fun upFildImg(data: List<String>) {
        val uploadTags = java.util.ArrayList<UploadTag>()
        showLoadingDialog("正在上传，请稍候...", false, false)
        for (i in data.indices) {
            uploadTags.add(UploadTag(i.toString(), data.get(i)))
        }

        val uploadImage = RxUploadImage(this, uploadTags, StoreServerApi.FOLDER_TYPE_ORDER)
        uploadImage.setListener(object : RxUploadImage.UploadImageListener {
            override fun onSuccess(success: Int, tag: UploadTag) {
                mSuccessImages.add(tag.bucket)
            }

            override fun onError(e: Throwable) {
                dismissLoadingDialog()
            }

            override fun onComplete() {
                dismissLoadingDialog()
                var mUpGoodsList: ArrayList<UselectUpGoosBean> = ArrayList()

                when (applyRefundType) {
                    APPLY_REFUND_TYOE01 -> {
                        if (null != mPresenter) {
                            var user = AccountManager.getInstance().getUser();
                            if (null != user) {
                                mPresenter.upApplyRefund(user, ppOrderId, refundType, refundReasonTypeId!!, reason!!, mSuccessImages, mUpGoodsList)
                            }
                        }
                    }
                    APPLY_REFUND_TYOE03 -> {
                        imgType = false
                        upTypeFildImg()
                    }
                    APPLY_REFUND_TYOE04 -> {
                        if (null != mPresenter) {
                            var user = AccountManager.getInstance().getUser();
                            if (null != user) {
                                mPresenter.upApplyReplacement(user, ppOrderId, reason!!, mSuccessImages)
                            }
                        }
                    }
                }
            }
        })
        uploadImage.startUpload(AccountManager.getInstance().user)
    }


    //第二种上传
    fun upAdapterFildImg(goodsId: String, attrInfolist: ArrayList<UselectAttrBean>?, data: List<String>) {
        val uploadTags = java.util.ArrayList<UploadTag>()
        mapGoodsImgs[goodsId] = ArrayList<String>()
        showLoadingDialog("正在上传，请稍候...", false, false)
        for (i in data.indices) {
            uploadTags.add(UploadTag(i.toString(), data.get(i)))
        }

        val uploadImage = RxUploadImage(this, uploadTags, StoreServerApi.FOLDER_TYPE_ORDER)
        uploadImage.setListener(object : RxUploadImage.UploadImageListener {
            override fun onSuccess(success: Int, tag: UploadTag) {
                if (mapGoodsImgs.containsKey(goodsId)) {
                    var upImageList: ArrayList<String> = mapGoodsImgs[goodsId]!!
                    upImageList.add(tag.bucket)
                }
            }

            override fun onError(e: Throwable) {
                dismissLoadingDialog()
            }

            override fun onComplete() {
                dismissLoadingDialog()
                var mUpGoodsList: ArrayList<UselectUpGoosBean> = ArrayList()
                var upGoosBean = UselectUpGoosBean()
                upGoosBean.goodsId = goodsId
                upGoosBean.clearImageAll()
                val upImageList = mapGoodsImgs[goodsId]!!;
                upGoosBean.addImageAll(upImageList)

                for (item in attrInfolist!!) {
                    if (refundType == 1) {
                        item.num = item.refundableNum
                    }
                    upGoosBean.attr!!.add(item)
                }
                mUpGoodsList.add(upGoosBean)
                //重组完商品后清除上一个商品成功上传的图片
                if (mAdapter.data.size == mUpGoodsList.size) {
                    var imageArray: ArrayList<String> = ArrayList()
                    var user = AccountManager.getInstance().getUser();
                    if (null != user) {
                        mPresenter.upApplyRefund(user, ppOrderId, refundType, refundReasonTypeId!!, reason!!, imageArray, mUpGoodsList)
                    }
                }
            }
        })
        uploadImage.startUpload(AccountManager.getInstance().user)
    }

    /**
     * 第三种上传
     */
    fun upTypeFildImg() {
        var upGoosBean = UselectUpGoosBean()
        var mUpGoodsList: ArrayList<UselectUpGoosBean> = ArrayList()
        for (item in mAdapter.data) {
            upGoosBean.goodsId = item.goodsId
            for (arrtitem in item.attr!!) {
                if (refundType == 1) {
                    arrtitem.num = arrtitem.quantity
                }
                if (arrtitem.num != 0) {
                    upGoosBean.attr!!.add(arrtitem)
                }
            }
        }
        mUpGoodsList.add(upGoosBean)
        var user = AccountManager.getInstance().getUser();
        if (null != user) {
            mPresenter.upApplyRefund(user, ppOrderId, refundType, refundReasonTypeId!!, reason!!, mSuccessImages, mUpGoodsList)
        }
    }


    private fun addGoodsData() {
        mAdapter.addImgVisibility(true)
        mAdapter.LinearLayoutVisibility(false)
        if (mQuanPrice.isNotBlank()) {
            mTvPrice.setText(String.format("%s", mQuanPrice))
        }
        var goodslist: ArrayList<UselectGoodsBean> = ArrayList()

        val mStringBuilder = StringBuilder();
        var goodsSize = 0
        for (i in goodsSelectList) {
            for (attrItem in i.attr!!) {
                if (attrItem.refundableNum != 0) {
                    mStringBuilder.append(String.format("%s*%s(编号:%s)", attrItem.specName, attrItem.refundableNum, attrItem.specNo)).append(",")
                    goodsSize += attrItem.refundableNum!!
                }
                var skuText = ""
                if (mStringBuilder.length > 0) {
                    skuText = mStringBuilder.substring(0, mStringBuilder.length - 1)
                } else {
                    skuText = mStringBuilder.toString()
                }
                i.skuDetail = skuText
            }
            i.size = goodsSize
        }

        goodslist.addAll(goodsSelectList)
        mAdapter.data.clear()
        mAdapter.addData(goodslist)
        mAdapter.notifyDataSetChanged()
    }

    override fun onLoadGoodsData(bean: UselectRefundGoodsBean) {
        goodsSelectList = bean.goodsBean
        if (bean.totalPrice!!.isNotBlank()) {
            mQuanPrice = bean.totalPrice!!
            mTvPrice.hint = String.format("订单总价%s", mQuanPrice)
        }
        if (null != mSelectGoodsList) {
            mSelectGoodsList.clear()
        }
        mSelectGoodsList.addAll(goodsSelectList)
    }

    override fun onLoadReasonDialogData(bean: UselectRefundReasonBean) {
        setDialog(bean)
    }

    override fun onUpApplyRefundSuccess(bean: UselectApplyRefundBean) {
        dismissLoadingDialog()
        startActivity(Intent(UselectRefundDetailActivity.getRefundId(this, bean.Id, identiyType, true)))
        onBackPressed();
    }

    override fun onUpApplyReplacement(bean: IsUslectReplacementBean) {
        dismissLoadingDialog()
        startActivity(UselectRefundDetailActivity.getRefundId(this, bean.replacementId, ppOrderId, identiyType, true))
        onBackPressed();
    }

    override fun onError(errorMessage: String) {
        ToastUtils.show(errorMessage)
    }
}