package com.pipipifa.pilaipiwang.goodselect.ui.activity.refund

import android.content.Context
import android.content.Intent
import android.os.Bundle
import androidx.recyclerview.widget.LinearLayoutManager
import androidx.recyclerview.widget.RecyclerView
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import android.widget.TextView
import com.hjq.toast.ToastUtils
import com.pipipifa.pilaipiwang.AccountManager
import com.pipipifa.pilaipiwang.R
import com.pipipifa.pilaipiwang.goodselect.api.UselectSevice
import com.pipipifa.pilaipiwang.goodselect.model.UselectConsultationRecordBean
import com.pipipifa.pilaipiwang.goodselect.ui.adapter.UselectConsultationRecordAdapter
import com.ppwang.ppbase.base.net.ApiURLConfig
import com.pipipifa.pilaipiwang.net.Cmd
import com.pipipifa.pilaipiwang.ui.BaseActivity
import com.ppwang.ppbase.base.ui.view.loadview.LoadingLayout
import com.ppwang.ppbase.base.net.param.MapServerValue
import com.ppwang.ppbase.base.net.request.OkGoRequestUtil

//协商记录
class UselectConsultationRecordActivity : BaseActivity() {
    lateinit var mRecyclerView: androidx.recyclerview.widget.RecyclerView
    lateinit var mAdapter: UselectConsultationRecordAdapter
    lateinit var mLoadingLayout: LoadingLayout

    var ppOrderId = ""
    var identiyType = 0
    var okhttps = OkGoRequestUtil()

    companion object {
        var PPORDERID = "ppOrderId"
        var IDENTIYTYPE = "identiyType"
        @JvmStatic
        fun getRefundId(context: Context, ppOrderId: String?, identiyType: Int): Intent {
            val intent = Intent(context, UselectConsultationRecordActivity::class.java)
            intent.putExtra(PPORDERID, ppOrderId)
            intent.putExtra(IDENTIYTYPE, identiyType)
            return intent
        }
    }

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_uselect_consultation_record)
        initIntent(intent)
        initView()
        loadData()
    }

    private fun initIntent(intent: Intent) {
        var getStringExtra = intent.getStringExtra(UselectRefundDetailActivity.PPORDERID)
        if (null != getStringExtra) {
            ppOrderId = intent.getStringExtra(UselectRefundDetailActivity.PPORDERID)
        }

        var getIntExtra = intent.getIntExtra(UselectRefundDetailActivity.IDENTIYTYPE, 0)
        if (null != getIntExtra) {
            identiyType = intent.getIntExtra(UselectRefundDetailActivity.IDENTIYTYPE, 0)
        }
    }


    private fun initView() {
        mRecyclerView = findViewById(R.id.content_layout);
        mLoadingLayout = findViewById(R.id.loading_layout);

        mAdapter = UselectConsultationRecordAdapter()
        mRecyclerView.layoutManager = androidx.recyclerview.widget.LinearLayoutManager(this)
        mRecyclerView.adapter = mAdapter

        mLoadingLayout = findViewById(R.id.loading_layout)
        mLoadingLayout.setEmptyView(createEmptyView())
        mLoadingLayout.showLoading()
    }

    private fun createEmptyView(): View {
        val emptyView = LayoutInflater.from(this).inflate(R.layout.empty_template, null) as ViewGroup
        val emptyText = emptyView.findViewById(R.id.empty_text) as TextView
        emptyText.text = "没有数据"
        emptyText.setTextColor(resources.getColor(R.color.text_color_999999))
        emptyText.setCompoundDrawablesWithIntrinsicBounds(0, R.drawable.ic_empty_message_list, 0, 0)
        val params = ViewGroup.LayoutParams(ViewGroup.LayoutParams.MATCH_PARENT, ViewGroup.LayoutParams.MATCH_PARENT)
        emptyView.layoutParams = params
        return emptyView
    }

    private fun loadData() {
        var user = AccountManager.getInstance().getUser();
        if (null == user) {
            return
        }
        var value = MapServerValue()
        value.addValue(UselectSevice.creatParam51003(user, ppOrderId!!, identiyType))
        okhttps.post(ApiURLConfig.goodsUrl(), value) { response ->
            if (response.hasError()) {
                ToastUtils.show(response.errorMessage)
            } else {
                val map = response.get()
                var data: UselectConsultationRecordBean = map.get(Cmd.REQUEST_CODE_51003) as UselectConsultationRecordBean
                if (null != data) {
                    mAdapter.setNewData(data.list)
                    mLoadingLayout.showContent()
                } else {
                    mLoadingLayout.showEmptyView()
                }
            }
        }
    }
}