package com.pipipifa.pilaipiwang.goodselect.ui.activity.refund

import android.app.Activity
import android.content.Context
import android.content.Intent
import android.os.Bundle
import android.view.View
import android.widget.EditText
import android.widget.TextView
import com.hjq.toast.ToastUtils
import com.ppwang.uikit.widget.roundwidget.PUIRoundTextView
import com.pipipifa.pilaipiwang.AccountManager
import com.pipipifa.pilaipiwang.R
import com.pipipifa.pilaipiwang.goodselect.api.UselectSevice
import com.pipipifa.pilaipiwang.goodselect.model.UselectRefundAddreaBean
import com.pipipifa.pilaipiwang.goodselect.utlis.ClipbordUtil
import com.ppwang.ppbase.base.net.ApiURLConfig
import com.pipipifa.pilaipiwang.net.Cmd
import com.pipipifa.pilaipiwang.ui.BaseActivity
import com.pipipifa.pilaipiwang.ui.dialog.common.DefaultDialog
import com.pipipifa.util.InputUtil
import com.ppwang.ppbase.base.net.param.MapServerValue
import com.ppwang.ppbase.base.net.request.OkGoRequestUtil


//发货
class UselectDeliveryActivity : BaseActivity() {
    lateinit var mSelectCourier: TextView

    lateinit var mSubmit: PUIRoundTextView

    lateinit var mAddrea: TextView

    lateinit var mExpressSn: EditText

    lateinit var mCopyText: PUIRoundTextView

    val REQUEST_CODE_COUNIER_ID = 1
    var counierName: String = ""
    var copyText: String = ""

    var ppOrderId: String? = null

    var expressCode: String = ""
    var expressSn: String? = ""

    var okhttp = OkGoRequestUtil()


    companion object {
        var PPORDERID = "ppOrderId"
        @JvmStatic
        fun getRefundId(context: Context, ppOrderId: String?): Intent {
            val intent = Intent(context, UselectDeliveryActivity::class.java)
            intent.putExtra(PPORDERID, ppOrderId)
            return intent
        }
    }

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)

        setContentView(R.layout.activity_uselect_refund_delivery)
        initIntent(intent)
        initView()
        loadData()
    }


    override fun onNewIntent(intent: Intent) {
        super.onNewIntent(intent)
        initIntent(intent)
    }

    private fun initIntent(intent: Intent) {
        var getStringExtra = intent.getStringExtra(UselectRefundDetailActivity.PPORDERID)
        if (null != getStringExtra) {
            ppOrderId = intent.getStringExtra(UselectRefundDetailActivity.PPORDERID)
        }
    }

    private fun initView() {
        mSelectCourier = findViewById(R.id.tv_select_courier)
        mSubmit = findViewById(R.id.pui_button_delivery_submit)
        mAddrea = findViewById(R.id.tv_refund_delivery_addrea)
        mExpressSn = findViewById(R.id.et_expressSn)
        mCopyText = findViewById(R.id.pui_text_copy)

        InputUtil.addFilter(mExpressSn, InputUtil.SetPattenFilter(InputUtil.SetPattenFilter.TEXE_CODE))
        mSelectCourier.setOnClickListener {
            var intent = Intent(this, UselectSelectCounierActivity::class.java)
            intent.putExtra(UselectSelectCounierActivity.COUNIER_ID, expressCode)
            startActivityForResult(intent, REQUEST_CODE_COUNIER_ID)
        }

        mSubmit.setOnClickListener {
            expressSn = mExpressSn.text.toString().trim()
            if (expressCode.isBlank()) {
                ToastUtils.show("请选择快递公司")
                return@setOnClickListener
            }

            if (expressSn!!.isBlank()) {
                ToastUtils.show("请填写快递单号")
                return@setOnClickListener
            }
            var dialog = DefaultDialog(this as Context)
            dialog.setTitle("提示")
            dialog.setMessage("请确认提交的物流信息是否正确？")
            dialog.setOkButton("确定", View.OnClickListener {
                dialog.cancel()
                courierRefund()
            })
            dialog.setCancelButton("取消", View.OnClickListener { dialog.cancel() })
            dialog.show()

        }

        mCopyText.setOnClickListener {
            if (copyText.isNotBlank()) {
                ToastUtils.show("退款信息复制成功")
                ClipbordUtil.copyText2Clipbord(this, copyText)
            }
        }
    }


    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        if (resultCode == Activity.RESULT_OK && requestCode == REQUEST_CODE_COUNIER_ID) {
            var getStringExtra = data?.getStringExtra(UselectSelectCounierActivity.COUNIER_ID)
            if (null != getStringExtra) {
                expressCode = data?.getStringExtra(UselectSelectCounierActivity.COUNIER_ID).toString()
                counierName = data?.getStringExtra(UselectSelectCounierActivity.COUNIER_NAME).toString()
                if (counierName.isNotBlank()) {
                    mSelectCourier.setText(counierName)
                }
            }
        }
    }


    fun loadData() {
        var user = AccountManager.getInstance().getUser();
        if (null == user) {
            return
        }
        var value = MapServerValue()
        value.addValue(UselectSevice.creatParam51007(user, ppOrderId!!))
        okhttp.post(ApiURLConfig.goodsUrl(), value) { response ->
            if (response.hasError()) {
                ToastUtils.show(response.errorMessage)
            } else {
                val map = response.get()
                var refundAddreaBean: UselectRefundAddreaBean = map.get(Cmd.REQUEST_CODE_51007) as UselectRefundAddreaBean
                var addrea = String.format("退款地址:%s%s%s%s"
                        , refundAddreaBean.afterAreaProvince
                        , refundAddreaBean.afterAreaCity
                        , refundAddreaBean.afterAreaDistrict
                        , refundAddreaBean.afterAddress)
                var name = String.format("收货人:%s", refundAddreaBean.afterContact)
                var phone = String.format("手机号码:%s", refundAddreaBean.afterContactTel)
                copyText = addrea + "\n" + name + "\n" + phone
                mAddrea.setText(copyText)
            }
        }
    }

    fun courierRefund() {
        var user = AccountManager.getInstance().getUser();
        if (null == user) {
            return
        }
        var value = MapServerValue()
        value.addValue(UselectSevice.creatParam51006(user, ppOrderId!!, expressCode, expressSn!!))
        okhttp.post(ApiURLConfig.goodsUrl(), value) { response ->
            if (response.hasError()) {
                ToastUtils.show(response.errorMessage)
            } else {
                val map = response.get()
                var data: Boolean = map.get(Cmd.REQUEST_CODE_51006) as Boolean
                if (data) {
                    ToastUtils.show("提交发货成功")
                    setResult(Activity.RESULT_OK, Intent())
                    finish()
                } else {
                    ToastUtils.show(response.errorMessage)
                }
            }
        }
    }
}