package com.pipipifa.pilaipiwang.goodselect.ui.activity.refund

import android.app.Activity
import android.content.ClipData
import android.content.ClipboardManager
import android.content.Context
import android.content.Intent
import android.os.Bundle
import android.os.Handler
import android.os.Looper
import android.text.TextUtils
import android.view.View
import android.widget.LinearLayout
import android.widget.RelativeLayout
import android.widget.TextView
import androidx.core.content.ContextCompat
import androidx.recyclerview.widget.LinearLayoutManager
import androidx.recyclerview.widget.RecyclerView
import com.hjq.toast.ToastUtils
import com.pipipifa.pilaipiwang.AccountManager
import com.pipipifa.pilaipiwang.R
import com.pipipifa.pilaipiwang.goodselect.model.UselectRefundDetailBean
import com.pipipifa.pilaipiwang.goodselect.model.UselectReplacementDetailBean
import com.pipipifa.pilaipiwang.goodselect.presenter.UselectRefundDetailResultContrat
import com.pipipifa.pilaipiwang.goodselect.ui.activity.arbitration.UselectApplyArbitrationActivity
import com.pipipifa.pilaipiwang.goodselect.ui.activity.arbitration.UselectArbitationDetailActivity
import com.pipipifa.pilaipiwang.goodselect.ui.adapter.UselectImageAdapter
import com.pipipifa.pilaipiwang.goodselect.ui.adapter.UselectRefundDetailAdapter
import com.pipipifa.pilaipiwang.goodselect.view.UselectTopbarRefundDetailView
import com.pipipifa.pilaipiwang.model.eventbus.ReplacementEventMessage
import com.pipipifa.pilaipiwang.photoselector.model.PhotoModel
import com.pipipifa.pilaipiwang.photoselector.ui.PhotoPreviewActivity
import com.pipipifa.pilaipiwang.presenter.base.BaseMvpActivity
import com.pipipifa.pilaipiwang.ui.activity.other.WebShopgetMoneyActivity
import com.pipipifa.pilaipiwang.ui.activity.seller.BuyerOrderDetailActivity
import com.pipipifa.pilaipiwang.ui.activity.seller.SellerOrderDetailActivity
import com.pipipifa.pilaipiwang.ui.dialog.common.DefaultDialog
import com.pipipifa.util.DateUtils
import com.pipipifa.util.StringUtil
import com.ppwang.uikit.widget.roundwidget.PUIRoundTextView
import org.greenrobot.eventbus.EventBus
import java.util.*

class UselectRefundDetailActivity : BaseMvpActivity<UselectRefundDetailResultContrat.Presenter>(), UselectRefundDetailResultContrat.IView {
    lateinit var mTopbar: UselectTopbarRefundDetailView
    lateinit var mRecyclerView: RecyclerView
    var identiyType = 0
    // 如果是0显示退款详情的页面UI  如果是1显示补发补货的UI
    var refundType = false

    lateinit var mHearder: View
    lateinit var mFooder: View

    lateinit var mAdapter: UselectRefundDetailAdapter
    private val listener = OnStatusListener()

    lateinit var mTvState: TextView
    lateinit var mTvAddTime: TextView
    lateinit var mTvOrderAddTime: TextView
    lateinit var mTvAgreedTime: TextView
    lateinit var mTvGoodsType: TextView
    lateinit var mTvMchDisagreeTime: TextView
    lateinit var mTvBuyerName: TextView
    lateinit var mTvSellerName: TextView
    lateinit var mTvRefundNum: TextView
    lateinit var mTvRefundtype: TextView
    lateinit var mTvRefundFee: TextView
    lateinit var mTvTypeContent: TextView
    lateinit var mTvProofreason: TextView
    lateinit var mLlGoodsList: LinearLayout
    lateinit var mFlowStatusRemarks: TextView
    lateinit var mCopy: TextView
    lateinit var mllAgreedTime: LinearLayout
    lateinit var mLLMchDisagreeTime: LinearLayout

    lateinit var mLlImgList: LinearLayout
    lateinit var mImgRecyclerView: RecyclerView
    lateinit var mImgAdapter: UselectImageAdapter
    lateinit var mButton01: PUIRoundTextView
    lateinit var mButton02: PUIRoundTextView
    lateinit var mButton03: PUIRoundTextView

    lateinit var mRlRefresh: RelativeLayout
    lateinit var mBtRefresh: PUIRoundTextView

    lateinit var mTvSn: TextView

    var ppOrderId: String? = null
    var orderId: String? = null
    var mUdesk: String? = ""
    var mContactTel: String? = ""
    var synchtype = false
    var replacementid: String? = ""
    var examineImgStutas = true
    val timer = Timer()

    companion object {
        var PPORDERID = "ppOrderId"
        var IDENTIYTYPE = "identiyType"
        var COURIERREFUND = 1
        var SYNCHTYPE = "synchtype"
        var REPLACEMENTID = "replacementId"

        /**
         * 退款详情的数据
         */
        @JvmStatic
        fun getRefundId(context: Context, ppOrderId: String?, identiyType: Int): Intent {
            val intent = Intent(context, UselectRefundDetailActivity::class.java)
            intent.putExtra(PPORDERID, ppOrderId)
            intent.putExtra(IDENTIYTYPE, identiyType)
            return intent
        }

        /**
         * 退款详情的数据
         */
        @JvmStatic
        fun getRefundId(context: Context, ppOrderId: String?, identiyType: Int, synchtype: Boolean): Intent {
            val intent = Intent(context, UselectRefundDetailActivity::class.java)
            intent.putExtra(PPORDERID, ppOrderId)
            intent.putExtra(IDENTIYTYPE, identiyType)
            intent.putExtra(SYNCHTYPE, synchtype)
            return intent
        }


        /**
         * 补发货跳转的ID  replacementId
         */
        @JvmStatic
        fun getRefundId(context: Context, replacementId: String?, ppOrderId: String?, identiyType: Int): Intent {
            val intent = Intent(context, UselectRefundDetailActivity::class.java)
            intent.putExtra(PPORDERID, ppOrderId)
            intent.putExtra(IDENTIYTYPE, identiyType)
            intent.putExtra(REPLACEMENTID, replacementId)
            return intent
        }

        /**
         * 补发货跳转的ID  replacementId  并且同步
         */
        @JvmStatic
        fun getRefundId(context: Context, replacementId: String?, ppOrderId: String?, identiyType: Int, synchtype: Boolean): Intent {
            val intent = Intent(context, UselectRefundDetailActivity::class.java)
            intent.putExtra(REPLACEMENTID, replacementId)
            intent.putExtra(PPORDERID, ppOrderId)
            intent.putExtra(IDENTIYTYPE, identiyType)
            intent.putExtra(SYNCHTYPE, synchtype)
            return intent
        }
    }

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_uselect_refund_detail)
        initIntent(intent)
        initView()
        initTopBar()
        mPresenter = UselectRefundDetailResultContrat.Presenter(this)
        if (synchtype) {
            isFastDouble()
        } else {
            loadData()
        }
    }

    fun isFastDouble() {
        showLoadingDialog("正在同步数据...", true, false)
        timer.schedule(object : TimerTask() {

            override fun run() {
                Handler(Looper.getMainLooper()).post {
                    dismissLoadingDialog()
                    loadData()
                }
            }
        }, 3000)
    }

    override fun onDestroy() {
        super.onDestroy()
        if (null != timer) {
            timer.cancel()
            timer == null
        }
    }

    fun loadData() {
        var user = AccountManager.getInstance().user
        if (user != null) {
            if (!TextUtils.isEmpty(replacementid)) {
                mPresenter.loadReplacement(user, identiyType, replacementid!!)
            } else {
                mPresenter.loadData(user, identiyType, ppOrderId!!)
            }
        }
    }

    override fun onNewIntent(intent: Intent) {
        super.onNewIntent(intent)
        initIntent(intent)
    }

    private fun initIntent(intent: Intent) {
        var getStringExtra = intent.getStringExtra(PPORDERID)
        if (null != getStringExtra) {
            ppOrderId = intent.getStringExtra(PPORDERID)
        }

        var getIntExtra = intent.getIntExtra(IDENTIYTYPE, 0)
        if (null != getIntExtra) {
            identiyType = intent.getIntExtra(IDENTIYTYPE, 0)
        }

        var getBooleanExtra = intent.getBooleanExtra(SYNCHTYPE, false)
        if (null != getBooleanExtra) {
            synchtype = intent.getBooleanExtra(SYNCHTYPE, false)
        }

        var getReplacementid = intent.getStringExtra(REPLACEMENTID)
        if (null != getReplacementid) {
            replacementid = intent.getStringExtra(REPLACEMENTID)
        }
    }

    private fun initView() {
        mTopbar = findViewById(R.id.topbar_refund_detail)
        mRecyclerView = findViewById(R.id.rv_refund_detail)
        mRlRefresh = findViewById(R.id.rl_empty_refresh)
        mBtRefresh = findViewById(R.id.pui_button_delivery_refresh)
        mRlRefresh.visibility = View.GONE

        initHeader();
        initFooder();
        mRecyclerView.layoutManager = LinearLayoutManager(this)
        mAdapter = UselectRefundDetailAdapter()
        mRecyclerView.adapter = mAdapter
        mAdapter.addHeaderView(mHearder)
        mAdapter.addFooterView(mFooder)

        mBtRefresh.setOnClickListener {
            loadData()
        }
    }


    private fun initTopBar() {
        if (TextUtils.isEmpty(replacementid)) {
            mTopbar.setTitle("退款详情")
            refundType = false
        } else {
            refundType = true
            mTopbar.setTitle("补发详情")
        }

        mTopbar.showStore(identiyType, refundType, object : UselectTopbarRefundDetailView.MenuItemListener {
            //协商记录
            override fun onConsultationRecord() {
                startActivity(Intent(UselectConsultationRecordActivity.getRefundId(this@UselectRefundDetailActivity, ppOrderId, identiyType)))
            }

            //原订单详情
            override fun onOrderDetail() {
                if (identiyType == 0) {
                    startActivity(Intent(BuyerOrderDetailActivity.getIntent(this@UselectRefundDetailActivity, ppOrderId, true)))
                } else {
                    startActivity(Intent(SellerOrderDetailActivity.getIntent(this@UselectRefundDetailActivity, ppOrderId, true)))
                }
            }

            override fun onOrderProcess() {
//                startActivity(Intent(this, UselectRefundProcessActivity::class.java))
            }

        })
        mTopbar.addOnBackClickListener(object : UselectTopbarRefundDetailView.OnBackClickListener {
            override fun OnClick() {
                finish()
            }
        })
    }


    private fun initHeader() {
        mHearder = LinearLayout.inflate(this, R.layout.uselect_item_header_refund_detail, null)
        mTvState = mHearder.findViewById(R.id.tv_refund_detail_state)
        mTvAddTime = mHearder.findViewById(R.id.tv_refund_detail_addTime)
        mTvOrderAddTime = mHearder.findViewById(R.id.tv_refund_detail_orderAddTime)
        mTvAgreedTime = mHearder.findViewById(R.id.tv_refund_detail_agreedTime)
        mTvMchDisagreeTime = mHearder.findViewById(R.id.tv_refund_detail_mchDisagreeTime)
        mTvGoodsType = mHearder.findViewById(R.id.tv_refund_detail_return_goods_type)

        mTvBuyerName = mHearder.findViewById(R.id.tv_refund_detail_buyer_name)
        mTvSellerName = mHearder.findViewById(R.id.tv_refund_detail_seller_name)
        mTvRefundNum = mHearder.findViewById(R.id.tv_refund_detail_refund_num)
        mTvRefundtype = mHearder.findViewById(R.id.tv_refund_detail_refundtype)
        mTvRefundFee = mHearder.findViewById(R.id.tv_refund_detail_refundFee)
        mTvTypeContent = mHearder.findViewById(R.id.tv_refund_detail_type_content)
        mTvProofreason = mHearder.findViewById(R.id.tv_refund_detail_proofreason)
        mLlGoodsList = mHearder.findViewById(R.id.ll_refund_header_goodslist)
        mFlowStatusRemarks = mHearder.findViewById(R.id.tv_refund_detail_flowStatusRemarks)
        mCopy = mHearder.findViewById(R.id.tv_order_no_copy)
        mllAgreedTime = mHearder.findViewById(R.id.ll_refund_detail_agreedTime)
        mLLMchDisagreeTime = mHearder.findViewById(R.id.ll_refund_detail_mchDisagreeTime)
        var mInfoType: TextView = mHearder.findViewById(R.id.tv_info_type)

        mTvSn = mHearder.findViewById(R.id.tv_refund_sn);

        if (!TextUtils.isEmpty(replacementid)) {
            mTvSn.setText("补发单号")
            mInfoType.setText("补发信息")
        } else {
            mTvSn.setText("退款单号")
            mInfoType.setText("退款信息")
        }
    }

    private fun initFooder() {
        mFooder = LinearLayout.inflate(this, R.layout.uselect_item_fooder_refund_detail, null)
        mLlImgList = mFooder.findViewById(R.id.ll_refund_header_imglist)
        mImgRecyclerView = mFooder.findViewById(R.id.rv_refund_detail_imglist)
        mButton01 = mFooder.findViewById(R.id.pui_refund_button01)
        mButton02 = mFooder.findViewById(R.id.pui_refund_button02)
        mButton03 = mFooder.findViewById(R.id.pui_refund_button03)
        mButton01.visibility = View.GONE
        mButton02.visibility = View.GONE
        mButton03.visibility = View.GONE
        mButton01.setOnClickListener(listener)
        mButton02.setOnClickListener(listener)
        mButton03.setOnClickListener(listener)

        mImgRecyclerView.layoutManager = LinearLayoutManager(this, LinearLayoutManager.HORIZONTAL, false)
        mImgRecyclerView.adapter = UselectImageAdapter()
        mImgAdapter = UselectImageAdapter()
        mImgRecyclerView.adapter = mImgAdapter
        mImgAdapter.setOnItemClickListener { adapter, view, position ->
            if (mImgAdapter.data.size > 0) {
                val photos = ArrayList<PhotoModel>()
                val intent = Intent(this, PhotoPreviewActivity::class.java)
                val bundle = Bundle()
                for (i in mImgAdapter.data.indices) {
                    val photoModel = PhotoModel()
                    photoModel.setOriginalPath(mImgAdapter.data.get(i))
                    photos.add(photoModel)
                }
                bundle.putInt(PhotoPreviewActivity.IMAGE_POSITION, position)
                bundle.putSerializable(PhotoPreviewActivity.IMAGE_PHOTOS, photos)
                intent.putExtras(bundle)
                startActivity(intent)
                examineImgStutas = false
            }
        }
    }


    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        if (resultCode == Activity.RESULT_OK) {
            if (requestCode == COURIERREFUND) {
                loadData()
            }
        }
    }


    private fun bindHearderData(data: UselectRefundDetailBean?) {
        mTvState.setText(data?.flowStatusName)
        mTvAddTime.setText(DateUtils.dateToString(Date(data?.orderAddTime!! * 1000), DateUtils.FORMAT_STRING_DATE_TIME))
        mTvOrderAddTime.setText(DateUtils.dateToString(Date(data?.addTime!! * 1000), DateUtils.FORMAT_STRING_DATE_TIME))
        if (data.mchAgreeTime == 0L) {
            mllAgreedTime.visibility = View.GONE
        } else {
            mTvAgreedTime.visibility = View.VISIBLE
            mTvAgreedTime.setText(DateUtils.dateToString(Date(data?.mchAgreeTime!! * 1000), DateUtils.FORMAT_STRING_DATE_TIME))
        }

        if (data.mchDisagreeTime == 0L) {
            mLLMchDisagreeTime.visibility = View.GONE
        } else {
            mTvMchDisagreeTime.visibility = View.VISIBLE
            mTvMchDisagreeTime.setText(DateUtils.dateToString(Date(data?.mchDisagreeTime!! * 1000), DateUtils.FORMAT_STRING_DATE_TIME))
        }

        when (data.returnGoodsType) {
            0 -> {
                mTvGoodsType.setText("等待商家决定是否寄回")
            }
            1 -> {
                mTvGoodsType.setText("商家要求寄回")
            }
            2 -> {
                mTvGoodsType.setText("无需寄回")
            }
            3 -> {
                mTvGoodsType.visibility = View.GONE
            }
        }

        mTvBuyerName.setText(data?.userName)
        mTvSellerName.setText(data?.mchName)
        mTvRefundNum.setText(data?.refundNo)
        if (data?.refundType == "1") {
            mTvRefundtype.setText("全单退货,退款后订单结束")
        } else {
            mTvRefundtype.setText("部分退货,退款后订单继续")
        }
        mTvRefundFee.setText(data?.refundFee)
        mTvTypeContent.setText(data?.refundReasonTypeContent)
        mTvProofreason.setText(data?.proofReason)

        if (data!!.goodsImagesArray.isEmpty()) {
            mLlGoodsList.visibility = View.GONE
        } else {
            mLlGoodsList.visibility = View.VISIBLE
        }

        var time = DateUtils.getTimeDuring((data?.overtime!! * 1000) - System.currentTimeMillis()).getAddTime()
        var content = ((data?.flowStatusRemarks)!!.replace("\n", "<br>"))!!.replace("#OVERTIME#", "[" + time + "]")
        var contentString = StringUtil.formatColor(content, ContextCompat.getColor(this, R.color.red_color), ContextCompat.getColor(this, R.color.color_333333))
        mFlowStatusRemarks.setText(contentString)


        mCopy.setOnClickListener {
            ToastUtils.show("复制成功")
            val clipboardManager = getSystemService(Context.CLIPBOARD_SERVICE) as ClipboardManager
            clipboardManager.primaryClip = ClipData.newPlainText(null, data.refundNo)
        }
    }

    fun bindFooterData(data: UselectRefundDetailBean?) {
        mImgAdapter.setNewData(data!!.imagesArray)
        if (data?.imagesArray!!.isEmpty()) {
            mLlImgList.visibility = View.GONE
        } else {
            mLlImgList.visibility = View.VISIBLE
        }

        when (data?.flowStatus) {
            "1" -> {
                if (identiyType == 1) {
                    mButton01.visibility = View.GONE
                    mButton02.visibility = View.GONE
                    mButton03.visibility = View.GONE
                } else {
                    mTvState.setTextColor(ContextCompat.getColor(this, R.color.text_color_FF682F))
                    mButton01.visibility = View.VISIBLE
                    mButton02.visibility = View.GONE
                    mButton03.visibility = View.GONE
                    mButton01.setText("取消退款申请")
                    mllAgreedTime.visibility = View.GONE
                }
            }
            "10" -> {
                if (identiyType == 1) {
                    mButton01.visibility = View.GONE
                    mButton02.visibility = View.GONE
                    mButton03.visibility = View.GONE
                } else {
                    mTvState.setTextColor(ContextCompat.getColor(this, R.color.text_color_FF682F))
                    mButton01.visibility = View.VISIBLE
                    mButton02.visibility = View.VISIBLE
                    mButton03.visibility = View.GONE
                    mButton01.setText("寄回/查看退货地址")
                    mButton02.setText("取消退款申请")
                }
            }
            "30" -> {
                mTvState.setTextColor(ContextCompat.getColor(this, R.color.text_color_FF682F))
                mButton01.visibility = View.VISIBLE
                mButton02.visibility = View.GONE
                mButton03.visibility = View.GONE
                mButton01.setText("物流跟踪")
            }
            "12" -> {
                if (identiyType == 1) {
                    mButton01.visibility = View.GONE
                    mButton02.visibility = View.GONE
                    mButton03.visibility = View.GONE
                } else {
                    mTvState.setTextColor(ContextCompat.getColor(this, R.color.bonus_red))
                    mButton01.visibility = View.VISIBLE
                    mButton02.visibility = View.VISIBLE
                    mButton03.visibility = View.VISIBLE
                    mButton01.setText("申请平台介入(仲裁)")
                    mButton02.setText("取消退款申请")
                    mButton03.setText("联系平台客服")
                }
            }
            "102" -> {
                if (identiyType == 1) {
                    mTvState.setTextColor(ContextCompat.getColor(this, R.color.bonus_red))
                    mButton01.visibility = View.VISIBLE
                    mButton02.visibility = View.GONE
                    mButton03.visibility = View.VISIBLE
                    mButton01.setText("查看申请平台介入(仲裁)详情")
                    mButton03.setText("联系平台客服")
                } else {
                    mTvState.setTextColor(ContextCompat.getColor(this, R.color.bonus_red))
                    mButton01.visibility = View.VISIBLE
                    mButton02.visibility = View.VISIBLE
                    mButton03.visibility = View.VISIBLE
                    mButton01.setText("查看申请平台介入(仲裁)详情")
                    mButton02.setText("撤销仲裁申请")
                    mButton03.setText("联系平台客服")
                }
            }
            "101" -> {
                mTvState.setTextColor(ContextCompat.getColor(this, R.color.bonus_red))
                mButton01.visibility = View.VISIBLE
                mButton02.visibility = View.VISIBLE
                mButton03.visibility = View.GONE
                mButton01.setText("查看申请平台介入(仲裁)详情")
                mButton02.setText("联系平台客服")
            }
            "50", "60" -> {
                mButton01.visibility = View.GONE
                mButton02.visibility = View.GONE
                mButton03.visibility = View.GONE
                //测试使用
//                mButton01.setText("寄回/查看退货地址")
            }
        }
    }

    private fun bindReplacementHearderData(data: UselectReplacementDetailBean?) {
        mTvState.setText(data?.flowStatusName)
        mTvAddTime.setText(data!!.orderAddTime)
        mTvOrderAddTime.setText(data.addTime)
        mllAgreedTime.visibility = View.GONE
        mLLMchDisagreeTime.visibility = View.GONE

        mTvBuyerName.setText(data?.userName)
        mTvSellerName.setText(data?.mchName)
        mTvRefundNum.setText(data?.replacementNo)
        mTvRefundtype.setText(data.replacementTypeStr)
        mTvRefundFee.setText("- -")
        mTvGoodsType.setText("- -")
        mTvTypeContent.setText(data?.replacementReasonStr)
        mTvProofreason.setText(data?.reason)
        mLlGoodsList.visibility = View.GONE

        var content = ((data?.tipsMsg)!!.replace("\n", "<br>"))
        var contentString = StringUtil.formatColor(content, ContextCompat.getColor(this, R.color.red_color), ContextCompat.getColor(this, R.color.color_333333))
        mFlowStatusRemarks.setText(contentString)

        mCopy.setOnClickListener {
            ToastUtils.show("复制成功")
            val clipboardManager = getSystemService(Context.CLIPBOARD_SERVICE) as ClipboardManager
            clipboardManager.primaryClip = ClipData.newPlainText(null, data.replacementNo)
        }
    }

    fun bindReplacementFooterData(data: UselectReplacementDetailBean?) {
        if (data?.imagesArray!!.isEmpty()) {
            mLlImgList.visibility = View.GONE
        } else {
            mImgAdapter.setNewData(data!!.imagesArray)
            mLlImgList.visibility = View.VISIBLE
        }

        when (data?.flowStatus) {
            "0" -> {
                mTvState.setTextColor(ContextCompat.getColor(this, R.color.color_FC944D))
                if (identiyType == 1) {
                    mButton01.visibility = View.GONE
                    mButton02.visibility = View.GONE
                    mButton03.visibility = View.GONE
                } else {
                    mButton01.visibility = View.VISIBLE
                    mButton02.visibility = View.GONE
                    mButton03.visibility = View.GONE
                    mButton01.setText("取消申请")
                    mllAgreedTime.visibility = View.GONE
                }
            }
            "1" -> {
                mTvState.setTextColor(ContextCompat.getColor(this, R.color.color_FC944D))
                if (identiyType == 1) {
                    mButton01.visibility = View.VISIBLE
                    mButton02.visibility = View.VISIBLE
                    mButton03.visibility = View.GONE
                    mButton01.setText("查看物流")
                    mButton02.setText("联系平台客服")
                } else {
                    mButton01.visibility = View.VISIBLE
                    mButton02.visibility = View.VISIBLE
                    mButton03.visibility = View.VISIBLE
                    mButton01.setText("确认收货")
                    mButton02.setText("查看物流")
                    mButton03.setText("联系平台客服")
                }
            }
            "2" -> {
                mTvState.setTextColor(ContextCompat.getColor(this, R.color.text_color_19B360))
                mButton01.visibility = View.VISIBLE
                mButton02.visibility = View.GONE
                mButton03.visibility = View.GONE
                mButton01.setText("查看物流")
            }
            "3" -> {
                mTvState.setTextColor(ContextCompat.getColor(this, R.color.text_color_FF2727))
                mButton01.visibility = View.VISIBLE
                mButton02.visibility = View.GONE
                mButton03.visibility = View.GONE
                mButton01.setText("联系平台客服")
            }
            "4" -> {
                mTvState.setTextColor(ContextCompat.getColor(this, R.color.red_color))
                mButton01.visibility = View.GONE
                mButton02.visibility = View.GONE
                mButton03.visibility = View.GONE
                mButton01.setText("联系平台客服")
            }
            "5" -> {
                mTvState.setTextColor(ContextCompat.getColor(this, R.color.text_color_999999))
                mButton01.visibility = View.GONE
                mButton02.visibility = View.GONE
                mButton03.visibility = View.GONE
                mButton01.setText("联系平台客服")
            }
        }
    }

    private inner class OnStatusListener : View.OnClickListener {
        override fun onClick(v: View) {
            val txt = v as TextView
            val status = txt.text.toString()
            when (status) {
                "寄回/查看退货地址" -> {
                    startActivityForResult(Intent(UselectDeliveryActivity.getRefundId(this@UselectRefundDetailActivity, ppOrderId)), COURIERREFUND)
                }
                "取消退款申请" -> {
                    showDialog(status, "是否确定执行此操作？")
                }
                "联系平台客服" -> {
                    startActivity(WebShopgetMoneyActivity.getIntent(this@UselectRefundDetailActivity, mUdesk))
                }
                "物流跟踪" -> {
                    startActivity(Intent(UselectRefundExpressDetailActivity.getRefundId(this@UselectRefundDetailActivity, ppOrderId, identiyType)))
                }
                "申请平台介入(仲裁)" -> {
                    showDialog(status, "是否确定执行此操作？")
                }
                "查看申请平台介入(仲裁)详情" -> {
                    startActivity(Intent(UselectArbitationDetailActivity.getArbitrationId(this@UselectRefundDetailActivity, ppOrderId, identiyType)))
                }
                "撤销仲裁申请" -> {
                    showDialog(status, "撤回本次仲裁，则代表您同意并确认取消本次退款，是否确认此操作？")
                }
                //优选补货逻辑
                "查看物流" -> {
                    startActivity(Intent(UselectRefundExpressDetailActivity.getReplacementid(this@UselectRefundDetailActivity, replacementid)))
                }
                "取消申请" -> {
                    showDialog(status, "是否确认取消申请？")
                }
                "确认收货" -> {
                    showDialog(status, "【是否确认收货，确认后订单自动完成")
                }
            }
        }
    }

    fun showDialog(status: String, msg: String) {
        var dialog = DefaultDialog(this as Context)
        dialog.setMessage(msg)
        dialog.setTitle("提示")
        var user = AccountManager.getInstance().user
        dialog.setOkButton("确定") {
            dialog.cancel()
            when (status) {
                "取消退款申请" -> {
                    if (user != null) {
                        if (null != mPresenter) {
                            mPresenter.cancelRefund(user, ppOrderId!!)
                        }
                    }
                }
                "申请平台介入(仲裁)" -> {
                    startActivity(Intent(UselectApplyArbitrationActivity.getRefundId(this, ppOrderId)))
                }
                "撤销仲裁申请" -> {
                    if (user != null) {
                        if (null != mPresenter) {
                            mPresenter.undoArbitrationApply(user, ppOrderId!!)
                        }
                    }
                }
                "取消申请" -> {
                    if (user != null) {
                        if (null != mPresenter) {
                            mPresenter.cancelReplacement(user, replacementid!!)
                        }
                    }
                }
                "确认收货" -> {
                    if (user != null) {
                        if (null != mPresenter) {
                            mPresenter.confirmGoods(user, replacementid!!)
                        }
                    }
                }
            }
        }
        dialog.setCancelButton("取消", { dialog.cancel() })
        dialog.show()
    }

    override fun onLoadSuccess(bean: UselectRefundDetailBean) {
        mRlRefresh.visibility = View.GONE
        mRecyclerView.visibility = View.VISIBLE
        bindHearderData(bean)
        bindFooterData(bean)
        mUdesk = bean?.uDesk
        mContactTel = bean?.contactTel
        mAdapter.setNewData(bean.goodsImagesArray)
    }

    override fun onLoadReplacementSuccess(detailBeanUselect: UselectReplacementDetailBean) {
        mRlRefresh.visibility = View.GONE
        mRecyclerView.visibility = View.VISIBLE
        bindReplacementHearderData(detailBeanUselect)
        bindReplacementFooterData(detailBeanUselect)
        mUdesk = detailBeanUselect?.uDesk
        mContactTel = detailBeanUselect?.contactTel
    }

    override fun onCancelRefund(type: Boolean) {
        ToastUtils.show("操作成功")
        loadData()
    }

    override fun onCancelReplacement(type: Boolean) {
        ToastUtils.show("操作成功")
        loadData()
        val message = ReplacementEventMessage(ReplacementEventMessage.TYPE_CARD_DELETE,
                replacementid)
        EventBus.getDefault().post(message)
    }

    override fun onConfirmGoods(type: Boolean) {
        ToastUtils.show("操作成功")
        loadData()
        val message = ReplacementEventMessage(ReplacementEventMessage.TYPE_CARD_DELETE,
                replacementid)
        EventBus.getDefault().post(message)
    }

    override fun onLoadError(onLoadError: String) {
        mRlRefresh.visibility = View.VISIBLE
        mRecyclerView.visibility = View.GONE
        ToastUtils.show(onLoadError)
    }
}