package com.pipipifa.pilaipiwang.goodselect.ui.activity.refund

import android.content.Context
import android.content.Intent
import android.os.Bundle
import android.widget.TextView
import com.hjq.toast.ToastUtils
import com.pipipifa.pilaipiwang.AccountManager
import com.pipipifa.pilaipiwang.R
import com.pipipifa.pilaipiwang.goodselect.model.UselectExpressBean
import com.pipipifa.pilaipiwang.goodselect.presenter.UselectRefundExpressResultContrat
import com.pipipifa.pilaipiwang.goodselect.ui.adapter.UselectExpressAdapter
import com.pipipifa.pilaipiwang.goodselect.utlis.ClipbordUtil
import com.pipipifa.pilaipiwang.presenter.base.BaseMvpActivity

/**
 * @author: wangben
 * 优选物流跟踪
 */
class UselectRefundExpressDetailActivity : BaseMvpActivity<UselectRefundExpressResultContrat.Presenter>(), UselectRefundExpressResultContrat.IView {
    lateinit var mExpressStatusTv: TextView
    lateinit var mExpressCompanyTv: TextView
    lateinit var mExpressSnTv: TextView
    lateinit var mCopyText: TextView
    lateinit var mRecyclerView: androidx.recyclerview.widget.RecyclerView

    private val mAdapter = UselectExpressAdapter()
    private var mExpressBean: UselectExpressBean? = null

    var refundId: String = ""
    var replacementid: String = ""
    var identiyType = 0

    companion object {
        var REFUNDID = "refundId"
        var IDENTITYTYPE = "identityType"
        var REPLACEMENTID = "replacementid"
        @JvmStatic
        fun getRefundId(context: Context, refundId: String?, identiyType: Int): Intent {
            var intnet = Intent(context, UselectRefundExpressDetailActivity::class.java)
            intnet.putExtra(REFUNDID, refundId)
            intnet.putExtra(IDENTITYTYPE, identiyType)
            return intnet
        }

        @JvmStatic
        fun getReplacementid(context: Context, replacementid: String?): Intent {
            var intnet = Intent(context, UselectRefundExpressDetailActivity::class.java)
            intnet.putExtra(REPLACEMENTID, replacementid)
            return intnet
        }
    }

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_uselect_express_details)
        initIntent(intent)
        initView()
        mPresenter = UselectRefundExpressResultContrat.Presenter(this)
        var user = AccountManager.getInstance().user
        if (user != null && refundId.isNotBlank()) {
            mPresenter.loadData(user, refundId, identiyType)
        }
        if (user != null && replacementid.isNotBlank()) {
            mPresenter.replacementLoad(user, replacementid)
        }
    }


    override fun onNewIntent(intent: Intent) {
        super.onNewIntent(intent)
        initIntent(intent)
    }

    fun initIntent(intent: Intent) {
        var getStringExtra = intent.getStringExtra(REFUNDID)
        if (null != getStringExtra) {
            refundId = intent.getStringExtra(REFUNDID)
        }

        var getReplacementid = intent.getStringExtra(REPLACEMENTID)
        if (null != getReplacementid) {
            replacementid = intent.getStringExtra(REPLACEMENTID)
        }

        var getIntExtra = intent.getIntExtra(UselectApplyRefundActivity.IDENTITYTYPE, 0)
        if (null != getIntExtra) {
            identiyType = intent.getIntExtra(UselectApplyRefundActivity.IDENTITYTYPE, 0)
        }
    }


    private fun initView() {
        mExpressStatusTv = findViewById(R.id.tv_express_statue)
        mExpressCompanyTv = findViewById(R.id.tv_express_company)
        mExpressSnTv = findViewById(R.id.tv_express_no)
        mRecyclerView = findViewById(R.id.recyclerview)
        mCopyText = findViewById(R.id.tv_express_no_copy)
        mRecyclerView.layoutManager = androidx.recyclerview.widget.LinearLayoutManager(this)
        mRecyclerView.adapter = mAdapter

        mCopyText.setOnClickListener {
            if (mExpressBean != null) {
                ClipbordUtil.copyText2Clipbord(this, mExpressBean!!.express_no)
                ToastUtils.show("复制成功")
            }
        }
    }

    /**
     * 加载物流详情
     */

    override fun onLoadSuccess(bean: UselectExpressBean) {
        setExpressInfo(bean)
    }

    override fun onEmptyView(msg: String) {
        ToastUtils.show(msg)
    }

    /**
     * 填充订单数据
     */
    fun setExpressInfo(express: UselectExpressBean) {
        mExpressBean = express
        if (express.status_text.isNotBlank()) {
            mExpressStatusTv.text = String.format("物流状态：%s", express.status_text)
        }
        if (express.express.isNotBlank()) {
            mExpressCompanyTv.text = String.format("快递公司：%s", express.express)
        }
        if (express.express_no.isNotBlank()) {
            mExpressSnTv.text = String.format("快递单号：%s", express.express_no)
        }
        mAdapter.setNewData(express.list)
    }
}