package com.pipipifa.pilaipiwang.goodselect.ui.activity.refund

import android.os.Bundle
import com.hjq.toast.ToastUtils
import com.pipipifa.pilaipiwang.AccountManager
import com.pipipifa.pilaipiwang.R
import com.pipipifa.pilaipiwang.goodselect.api.UselectSevice
import com.pipipifa.pilaipiwang.goodselect.model.UselectProcessBean
import com.pipipifa.pilaipiwang.goodselect.ui.adapter.UselectRefundProcessAdapter
import com.ppwang.ppbase.base.net.ApiURLConfig
import com.pipipifa.pilaipiwang.net.Cmd
import com.pipipifa.pilaipiwang.presenter.user.LoginPresenter
import com.pipipifa.pilaipiwang.ui.BaseActivity
import com.pipipifa.pilaipiwang.ui.view.myrecycleview.ExPullRecycleView
import com.ppwang.ppbase.base.net.param.MapServerValue
import com.ppwang.ppbase.base.net.request.OkGoRequestUtil

//退款历程
class UselectRefundProcessActivity : BaseActivity() {
    lateinit var mRecyclerView: ExPullRecycleView
    lateinit var mAdapter: UselectRefundProcessAdapter

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_uselect_refund_process)
        initView()
        loadData()
    }

    private fun initView() {
        mRecyclerView = findViewById(R.id.rv_process)
        mAdapter = UselectRefundProcessAdapter()

    }

    private fun loadData() {
        var user = AccountManager.getInstance().user
        if (null == user) {
            LoginPresenter.getLoginIntent(this, false)
        }

        var params = MapServerValue()
        params.addValue(UselectSevice.creatParam51004(user, "11"))
        var okGoRequestUtil = OkGoRequestUtil()
        okGoRequestUtil.post(ApiURLConfig.goodsUrl(), params) { response ->
            if (response.hasError()) {
                ToastUtils.show(response.errorMessage)
            } else {
                var map = response.get()
                var data: UselectProcessBean = map.get(Cmd.REQUEST_CODE_51004) as UselectProcessBean
                if (null != data) {
                    mAdapter.setNewData(data.list)
                }
            }
        }
    }

}