package com.pipipifa.pilaipiwang.goodselect.ui.activity.refund

import android.os.Bundle
import android.text.TextUtils
import androidx.fragment.app.Fragment
import androidx.fragment.app.FragmentManager
import androidx.fragment.app.FragmentPagerAdapter
import androidx.viewpager.widget.ViewPager
import com.pipipifa.pilaipiwang.R
import com.pipipifa.pilaipiwang.goodselect.model.UselectReplacementOrderNum
import com.pipipifa.pilaipiwang.goodselect.ui.fragment.UselectReplacemertFragment
import com.pipipifa.pilaipiwang.ui.BaseActivity
import com.pipipifa.pilaipiwang.ui.view.PagerSlidingTabStrip
import java.util.*

/**
 * @author: wangben
 * @date: 2020/4/17
 */
class UselectReplacementActivity : BaseActivity() {
    val mTitles = arrayOf("补发进行中", "补发结束")
    var mFragments: ArrayList<UselectReplacemertFragment>? = null

    lateinit var mPager: ViewPager
    lateinit var mTabs: PagerSlidingTabStrip

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_uselect_replacement)
        getImmersionBar()
        initViews()
    }

    private fun initViews() {
        mPager = findViewById(R.id.vPager)
        mTabs = findViewById(R.id.tabs)
        mFragments = ArrayList()
        mFragments!!.add(UselectReplacemertFragment.newInstance(1) as UselectReplacemertFragment)
        mFragments!!.add(UselectReplacemertFragment.newInstance(2) as UselectReplacemertFragment)
        mPager.setAdapter(ReplacementPagerAdapter(supportFragmentManager))
        mTabs.setViewPager(mPager)
        mTabs.setTabTexts(mTitles)
    }

    open fun getOrderNum(list: ArrayList<UselectReplacementOrderNum>) {
        var num = ""
        for (i in 0 until list.size) {
            if (list.size == mTitles.size) {
                if (i == 0) {
                    if (!TextUtils.isEmpty(list.get(i).name!!)) {
                        if (list.get(i).num!! > 999) {
                            num = "${999}+"
                        }else{
                            num = "${list.get(i).num!!}"
                        }
                        mTitles[i] = String.format("%s\n(%s)", list.get(i).name!!, num)
                    }
                }
            }
        }
        mTabs.setTabTexts(mTitles)
    }

    private inner class ReplacementPagerAdapter(fm: FragmentManager) : FragmentPagerAdapter(fm) {

        override fun getItem(position: Int): Fragment {
            return mFragments!!.get(position)
        }

        override fun getCount(): Int {
            return mTitles.size
        }

        override fun getPageTitle(position: Int): CharSequence? {
            return mTitles[position]
        }
    }
}