package com.pipipifa.pilaipiwang.goodselect.ui.activity.refund

import android.app.Activity
import android.content.Intent
import android.os.Bundle
import androidx.recyclerview.widget.LinearLayoutManager
import androidx.recyclerview.widget.RecyclerView
import com.pipipifa.pilaipiwang.AccountManager
import com.pipipifa.pilaipiwang.R
import com.pipipifa.pilaipiwang.goodselect.model.UselectSelectCounierBean
import com.pipipifa.pilaipiwang.goodselect.presenter.UselectSelectCounierResultContrat
import com.pipipifa.pilaipiwang.goodselect.ui.adapter.UselectSelectCounierAdapter
import com.pipipifa.pilaipiwang.presenter.base.BaseMvpActivity
import com.ppwang.ppbase.base.net.request.OkGoRequestUtil

//选择快递公司
class UselectSelectCounierActivity : BaseMvpActivity<UselectSelectCounierResultContrat.Presenter>(), UselectSelectCounierResultContrat.IView {

    lateinit var mRecyclerView: RecyclerView
    lateinit var mAdapter: UselectSelectCounierAdapter

    var counierId: String? = null

    var ppOrderId = ""

    companion object {
        @JvmStatic
        var COUNIER_ID = "counier_id"
        var COUNIER_NAME = "counier_name"
    }

    var okhttp = OkGoRequestUtil()

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_uselect_select_counier)
        initView()
        mPresenter = UselectSelectCounierResultContrat.Presenter(this)
        if (null != mPresenter) {
            var user = AccountManager.getInstance().getUser();
            if (null != user) {
                mPresenter.loadData(user, ppOrderId)
            }
        }
    }

    private fun initView() {
        mRecyclerView = findViewById(R.id.rv_select_counier)

        mRecyclerView.layoutManager = LinearLayoutManager(this)
        mAdapter = UselectSelectCounierAdapter()
        mRecyclerView.adapter = mAdapter

        mAdapter.setOnItemClickListener { adapter, view, position ->
            var mBean = mAdapter.data.get(position)
            for (item in mAdapter.data) {
                item.select = false
            }
            mBean.select = true
            mAdapter.notifyDataSetChanged()
            val intent = Intent()
            intent.putExtra(COUNIER_ID, mBean.code)
            intent.putExtra(COUNIER_NAME, mBean.name)
            setResult(Activity.RESULT_OK, intent)
            onBackPressed()
        }

        if (null != counierId && counierId!!.isNotBlank()) {
            mAdapter.selectPosition(counierId!!)
            mAdapter.notifyDataSetChanged()
        }
    }

    override fun onLoadDataSuccess(bean: UselectSelectCounierBean) {
        if (null != bean) {
            mAdapter.setNewData(bean.list)
        }
    }
}