package com.pipipifa.pilaipiwang.goodselect.ui.activity.refund

import android.content.Context
import android.content.Intent
import android.os.Bundle
import android.view.View
import android.widget.ImageView
import android.widget.TextView
import com.ppwang.uikit.widget.topbar.PUITopBar
import com.pipipifa.pilaipiwang.R
import com.pipipifa.pilaipiwang.goodselect.model.UselectGoodsBean
import com.pipipifa.pilaipiwang.goodselect.ui.adapter.UselectSelectGoodsAdapter
import com.pipipifa.pilaipiwang.ui.BaseActivity
import com.ppwang.ppbase.base.ui.view.loadview.LoadingLayout
import com.ppwang.ppbase.utils.ArrayUtil
import kotlin.collections.ArrayList

class UselectSelectGoodsActivity : BaseActivity() {
    lateinit var goodslist: ArrayList<UselectGoodsBean>
    lateinit var mTopbar: PUITopBar

    lateinit var mRecyclerView: androidx.recyclerview.widget.RecyclerView

    lateinit var mAdapter: UselectSelectGoodsAdapter

    private lateinit var mLoadingLayout: LoadingLayout

    companion object {
        var GOODSLIST = "goodslist"
        @JvmStatic
        fun getGoods(context: Context, goodslist: ArrayList<UselectGoodsBean>?): Intent {
            val intent = Intent(context, UselectSelectGoodsActivity::class.java)
            intent.putExtra(GOODSLIST, goodslist)
            return intent
        }
    }

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_uselect_select_goods)
        initIntent(intent)
        initView()
    }

    private fun initIntent(intent: Intent) {
        var getStringArrayListExtra = intent.getStringArrayListExtra(GOODSLIST)
        if (null != getStringArrayListExtra) {
            goodslist = intent.getStringArrayListExtra(GOODSLIST) as ArrayList<UselectGoodsBean>
        }
    }

    private fun initView() {
        mTopbar = findViewById(R.id.topbar_select_goods)
        mRecyclerView = findViewById(R.id.content_layout)
        mRecyclerView.layoutManager = androidx.recyclerview.widget.LinearLayoutManager(this)
        mAdapter = UselectSelectGoodsAdapter()
        mRecyclerView.adapter = mAdapter
        mTopbar.setTitle("选择商品")
        setLoadingLayout()
        loadData()
        mAdapter.setOnItemClickListener { adapter, view, position ->
            var item = goodslist.get(position)
            startActivity(Intent(UselectSelectSKUActivity.getGoods(this, item)))
        }
    }

    private fun setLoadingLayout() {
        mLoadingLayout = findViewById(R.id.loading_layout)
        var emptyView = layoutInflater.inflate(R.layout.empty_center_layout, null)
        var ivEmpty: ImageView = emptyView.findViewById(R.id.iv_empty)
        var empty_text: TextView = emptyView.findViewById(R.id.tv_empty)
        ivEmpty.setBackgroundResource(R.drawable.icon_empty_order)
        ivEmpty.getLayoutParams()
        empty_text.visibility = View.VISIBLE
        mLoadingLayout.setEmptyView(emptyView)
        mLoadingLayout.showLoading()
    }


    /**
     * 添加商品数据
     */
    private fun loadData() {
        if (!ArrayUtil.isEmpty(goodslist) && goodslist!!.size > 0) {
            mAdapter.setNewData(goodslist!!)
        }
        if (mAdapter.data.size > 0) {
            mLoadingLayout.showContent()
        } else {
            mLoadingLayout.showEmptyView()
        }
    }
}