package com.pipipifa.pilaipiwang.goodselect.ui.activity.refund

import android.content.Context
import android.content.Intent
import android.os.Bundle
import android.text.Editable
import android.text.TextWatcher
import android.view.LayoutInflater
import android.view.View
import android.widget.EditText
import android.widget.LinearLayout
import android.widget.TextView
import com.facebook.drawee.view.SimpleDraweeView
import com.pipipifa.pilaipiwang.R
import com.pipipifa.pilaipiwang.goodselect.model.UselectAttrBean
import com.pipipifa.pilaipiwang.goodselect.model.UselectGoodsBean
import com.pipipifa.pilaipiwang.ui.BaseActivity
import com.ppwang.ppbase.utils.ButtonClickUtils
import java.util.*

class UselectSelectSKUActivity : BaseActivity() {

    lateinit var mDetermine: TextView
    lateinit var mGoodsConverSdv: SimpleDraweeView
    lateinit var mGoodsTitleTv: TextView
    lateinit var mGoodsPriceTv: TextView
    lateinit var mGoodsPriceContainer: View
    lateinit var mSkuEdtContainreLl: LinearLayout
    lateinit var mGradientPriceContainerLl: LinearLayout

    lateinit var mTvStock: TextView

    lateinit var mTvRefund: TextView


    var mGoodsData: UselectGoodsBean? = null

    var mAttrListList: ArrayList<UselectAttrBean> = ArrayList()
    var addImgType = false

    companion object {
        var GOODSBEAN = "goodsbean"
        @JvmStatic
        fun getGoods(context: Context, goodsbean: UselectGoodsBean?): Intent {
            val intent = Intent(context, UselectSelectSKUActivity::class.java)
            intent.putExtra(GOODSBEAN, goodsbean)
            return intent
        }
    }

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_uselect_select_sku)
        initIntent(intent)
        initView()
        // 修改购物车不显示价格，显示商品名
        mGoodsPriceContainer.visibility = View.GONE
        mGoodsTitleTv.visibility = View.VISIBLE
        if (null != mGoodsData) {
            setGoodsData(mGoodsData!!)
        }
    }

    private fun initIntent(intent: Intent?) {
        val serializableObject = intent?.getSerializableExtra(GOODSBEAN)
        if (serializableObject != null) {
            mGoodsData = intent.getSerializableExtra(GOODSBEAN) as UselectGoodsBean?
        }
    }

    private fun initView() {
        mDetermine = findViewById(R.id.tv_determine)
        mGoodsConverSdv = findViewById(R.id.sdv_goods_conver)
        mGoodsTitleTv = findViewById(R.id.tv_goods_title)
        mGoodsPriceTv = findViewById(R.id.tv_goods_price)
        mGoodsPriceContainer = findViewById(R.id.ll_goods_price_container)
        mSkuEdtContainreLl = findViewById(R.id.ll_sku_edt_container)
        mGradientPriceContainerLl = findViewById(R.id.ll_gradient_price_container)

        mTvStock = findViewById(R.id.tv_shop_man_num)
        mTvRefund = findViewById(R.id.tv_shop_select_num)

        mTvStock.setText("进货数量")
        mTvRefund.setText("退货数量")
        mDetermine.setOnClickListener {
            if (ButtonClickUtils.isFastDoubleClick()){
                for (i in mGoodsData?.attr!!) {
                    if (i.num == 0) {
                        addImgType = false
                    } else {
                        addImgType = true
                        break
                    }
                }

                if (addImgType) {
                    startActivity(Intent(UselectApplyRefundActivity.getGoods(this, mGoodsData)))
                } else {
                    startActivity(Intent(UselectApplyRefundActivity.getGoods(this, null)))
                }
            }
        }
    }


    /**
     * 填充商品数据
     */
    private fun setGoodsData(goods: UselectGoodsBean) {
        mGoodsTitleTv.setText(goods.goodsName)
        if (goods.coverPic.isNotBlank()) {
            mGoodsConverSdv.setImageURI(goods.coverPic)
        } else {
            mGoodsConverSdv.setBackgroundResource(R.drawable.uselect_icon_cate_img_default)
        }

        if (UselectAttrBean() != null) {
            mAttrListList = goods.attr!!
            for (attr in mAttrListList) {
                generateAttrEdtContainerView(attr)
            }
        }
    }

    /**
     * 生成 sku 编辑视图，并依附到 mSkuEdtContainreLl
     */
    private fun generateAttrEdtContainerView(attr: UselectAttrBean) {
        val attrContainer = LayoutInflater.from(this).inflate(R.layout.uselect_include_shop_cart_edt_sku_item,
                null, false)
        val mAttrStockTv: TextView = attrContainer.findViewById(R.id.tv_attr_stock)
        val mAttrNameTv: TextView = attrContainer.findViewById(R.id.tv_attr_name)
        val mAttrCartNumEt: EditText = attrContainer.findViewById(R.id.et_attr_cart_num)
        //重置SKU 里面 num的初始值
        attr.num = 0
        if (attr.specName.isNotBlank()) {
            mAttrNameTv.text = attr.specName
        }
        if (attr.refundableNum != 0) {
            val stockNum = attr.refundableNum
            if (stockNum != null && stockNum > 999) {
                mAttrStockTv.text = "999+"
            } else {
                mAttrStockTv.text = attr.refundableNum.toString()
            }
        } else {
            mAttrStockTv.text = "0"
        }
        mAttrCartNumEt.addTextChangedListener(object : TextWatcher {
            override fun beforeTextChanged(s: CharSequence?, start: Int, count: Int, after: Int) {

            }

            override fun onTextChanged(s: CharSequence?, start: Int, before: Int, count: Int) {

            }

            override fun afterTextChanged(s: Editable) {
                if (s.isEmpty() || s.toString().toIntOrNull() == null) {
                    mAttrCartNumEt.setText("0")
                    return
                }
                if (s.toString().toInt() > attr.refundableNum!!) {
                    mAttrCartNumEt.setText(attr.refundableNum.toString())
                    return
                }
                attr.num = s.toString().toInt()
                mAttrCartNumEt.setSelection(s.toString().length);
            }
        })

        attrContainer.findViewById<View>(R.id.tv_attr_cart_redum).setOnClickListener {
            // 减少
            var cartNum = attr.num ?: 0
            if (cartNum == null) {
                cartNum = 0
            }
            if (cartNum!! > 0) {
                cartNum = cartNum!! - 1
                mAttrCartNumEt.setText(cartNum.toString())
                attr.num = cartNum!!
            }
        }
        attrContainer.findViewById<View>(R.id.tv_attr_cart_add).setOnClickListener {
            // 增加
            var cartNum = attr.num ?: 0
            if (cartNum == null) {
                cartNum = 0
            }
            if (cartNum!! < attr.refundableNum!!) {
                cartNum = cartNum!! + 1
                mAttrCartNumEt.setText(cartNum.toString())
                attr.num = cartNum
            }
        }

        mSkuEdtContainreLl.addView(attrContainer,
                LinearLayout.LayoutParams(LinearLayout.LayoutParams.MATCH_PARENT,
                        LinearLayout.LayoutParams.WRAP_CONTENT))
    }
}