package com.pipipifa.pilaipiwang.goodselect.ui.adapter

import android.view.View
import android.widget.ImageView
import android.widget.LinearLayout
import android.widget.TextView
import androidx.recyclerview.widget.LinearLayoutManager
import androidx.recyclerview.widget.RecyclerView
import com.chad.library.adapter.base.BaseViewHolder
import com.facebook.drawee.view.SimpleDraweeView
import com.hjq.toast.ToastUtils
import com.pipipifa.pilaipiwang.R
import com.pipipifa.pilaipiwang.goodselect.model.UselectGoodsBean
import com.pipipifa.pilaipiwang.goodselect.utlis.BaseSingleAdapter
import com.ppwang.ppbase.utils.ArrayUtil

class UselectApplyRefundAdapter : BaseSingleAdapter<UselectGoodsBean>(R.layout.uselect_item_apply_refund) {

    var mLister: OnGoodsItemClickLister? = null
    var type = false
    var addImgtype = false
    var deteleImgtype = false
    var mImgageList: ArrayList<String> = ArrayList()
    fun OnGoodsItemClickLister(lister: OnGoodsItemClickLister) {
        this.mLister = lister
    }

    fun LinearLayoutVisibility(visibilityType: Boolean) {
        this.type = visibilityType
    }


    fun addImgVisibility(addImgType: Boolean) {
        this.addImgtype = addImgType
    }

    fun addImageList(list: ArrayList<String>) {
        this.mImgageList = list
    }

    fun deteleImageList(imageType: Boolean) {
        this.deteleImgtype = imageType
    }

    override fun convert(helper: BaseViewHolder, goods: UselectGoodsBean?) {
        val mRecyclerView: RecyclerView = helper.getView(R.id.my_rv_imglist)
        val mDetele: ImageView = helper.getView(R.id.iv_apply_detele)
        val mAddImg: ImageView = helper.getView(R.id.iv_add_img)
        val mGoodsConverSdv: SimpleDraweeView = helper.getView(R.id.sdv_goods_conver)
        val mGoodsNameTv: TextView = helper.getView(R.id.tv_goods_name)
        val mGoodsPriceTv: TextView = helper.getView(R.id.tv_goods_price)
        val mGoodsCountTv: TextView = helper.getView(R.id.tv_goods_count)
        val mGoodsSkuDetailTv: TextView = helper.getView(R.id.tv_goods_sku_detail)
        val mTvMaxImg: TextView = helper.getView(R.id.tv_apply_max_img)
        val mTvRefundNum: TextView = helper.getView(R.id.tv_goods_refundNum)
        val mLayoutAddimg: LinearLayout = helper.getView(R.id.ll_apply_item_visibility)
        mRecyclerView.setTag(goods)

        if (type) {
            mLayoutAddimg.visibility = View.GONE
            goods!!.clearImageAll()
        } else {
            mLayoutAddimg.visibility = View.VISIBLE
        }

        if (addImgtype) {
            mDetele.visibility = View.GONE
        } else {
            mDetele.visibility = View.VISIBLE
        }

        if (goods?.size == 0) {
            mTvRefundNum.visibility = View.GONE
        } else {
            mTvRefundNum.visibility = View.GONE
            mTvRefundNum.setText(String.format("退款%s件", goods?.size))
            mTvMaxImg.text = String.format("（最多能上传%s张）", goods!!.size)
            mGoodsCountTv.text = String.format("%s件", goods?.size)
        }
        mGoodsConverSdv.setImageURI(goods?.coverPic)
        mGoodsNameTv.text = goods?.goodsName
        mGoodsSkuDetailTv.text = goods?.skuDetail
        mGoodsPriceTv.text = goods!!.payPrice

        mDetele.setOnClickListener {
            if (null != mLister) {
                goods.clearImageAll()
                mLister!!.deteleItem(goods)
            }
        }

        if (deteleImgtype) {
            if (!ArrayUtil.isEmpty(mImgageList)) {
                goods.clearImageAll()
            }
        }

        mAddImg.setOnClickListener {
            if (goods.images != null && goods.images.size >= goods.size!!) {
                ToastUtils.show(String.format("最多可以选择%s张图片", goods.size!!))
                return@setOnClickListener
            }
            if (null != mLister) {
                if (deteleImgtype) {
                    goods.images.clear()
                }
                mLister!!.addItemImg(goods.size!!, goods.images)
            }
        }


        val linearLayoutManager = LinearLayoutManager(mContext, LinearLayoutManager.HORIZONTAL, false)
        mRecyclerView.layoutManager = linearLayoutManager

        var mAdapter: UselectAddImageAdapter? = null;
        if (mRecyclerView.adapter == null) {
            mAdapter = UselectAddImageAdapter()
            mRecyclerView.adapter = mAdapter
        } else {
            mAdapter = mRecyclerView.adapter as UselectAddImageAdapter;
        }

        if (deteleImgtype) {
            if (!ArrayUtil.isEmpty(mImgageList)) {
                mImgageList.clear()
                mAdapter.data.clear()
            }
        }


        if (null != mImgageList && mImgageList.size > 0) {
            goods.addImageAll(mImgageList)
            mAdapter!!.setNewData(mImgageList)
        } else {
            // 如果缓存图片为空，也要清除掉原来已加载的data
            mAdapter.setNewData(null)
        }

        mAdapter.onDeteleImgClickLister(object : UselectAddImageAdapter.onDeteleImgClickLister {
            override fun deteleImg(img: String) {
                mAdapter.data.remove(img);
                goods.images.remove(img)
                mAdapter.notifyDataSetChanged()
            }
        })
    }

    interface OnGoodsItemClickLister {
        fun addItemImg(position: Int, images: ArrayList<String>)
        fun deteleItem(goods: UselectGoodsBean?)
    }

}