package com.pipipifa.pilaipiwang.goodselect.ui.adapter

import android.content.Intent
import android.os.Bundle
import androidx.recyclerview.widget.LinearLayoutManager
import androidx.recyclerview.widget.RecyclerView
import android.view.View
import android.widget.ImageView
import android.widget.TextView
import com.chad.library.adapter.base.BaseViewHolder
import com.pipipifa.pilaipiwang.R
import com.pipipifa.pilaipiwang.goodselect.model.UselectProofListBean
import com.pipipifa.pilaipiwang.goodselect.utlis.BaseSingleAdapter
import com.pipipifa.pilaipiwang.photoselector.model.PhotoModel
import com.pipipifa.pilaipiwang.photoselector.ui.PhotoPreviewActivity
import com.pipipifa.util.DateUtils
import java.util.*

class UselectArbitrationCellAdapter : BaseSingleAdapter<UselectProofListBean>(R.layout.uselect_item_arbitration_cell_layout) {
    override fun convert(helper: BaseViewHolder?, item: UselectProofListBean?) {
        var mIvImg = helper?.getView<ImageView>(R.id.iv_item_arbitration_img)
        var mTvName = helper?.getView<TextView>(R.id.iv_item_arbitration_name)
        var mTvReason = helper?.getView<TextView>(R.id.iv_item_arbitration_reason)
        var mTvTime = helper?.getView<TextView>(R.id.iv_item_arbitration_time)
        var mRecyclerView = helper?.getView<androidx.recyclerview.widget.RecyclerView>(R.id.rv_item_arbitration)

        if (item?.userType == 1) {
            mIvImg?.setBackgroundResource(R.drawable.icon_arbitretion_buyer)
            mTvName?.setText(item.name)
        } else if (item?.userType == 2) {
            mIvImg?.setBackgroundResource(R.drawable.icon_arbitretion_seller)
            mTvName?.setText(item.name)
        } else {
            mIvImg?.setBackgroundResource(R.drawable.icon_arbitretion_uselect)
            mTvName?.setText("批批网客服")
        }
        mTvReason?.setText(item?.reason)
        mTvTime?.setText(DateUtils.dateToString(Date(item?.addTime!! * 1000), DateUtils.FORMAT_STRING_DATE_TIME))

        var mImgAdapter: UselectImageAdapter? = null;
        val linearLayoutManager = androidx.recyclerview.widget.LinearLayoutManager(mContext, androidx.recyclerview.widget.LinearLayoutManager.HORIZONTAL, false)
        mRecyclerView?.layoutManager = linearLayoutManager
        mRecyclerView?.adapter = mImgAdapter

        if (mRecyclerView?.adapter == null) {
            mImgAdapter = UselectImageAdapter()
            mRecyclerView?.adapter = mImgAdapter
        } else {
            mImgAdapter = mRecyclerView.adapter as UselectImageAdapter;
        }


        if (null != item?.proofJson && item!!.proofJson.size > 0) {
            mImgAdapter.data.clear()
            mImgAdapter.setNewData(item!!.proofJson)
        } else {
            mRecyclerView?.visibility = View.GONE
        }

        mImgAdapter.setOnItemClickListener { adapter, view, position ->
            if (mImgAdapter.data.size > 0) {
                val photos = ArrayList<PhotoModel>()
                val intent = Intent(mContext, PhotoPreviewActivity::class.java)
                val bundle = Bundle()
                for (i in mImgAdapter.data.indices) {
                    val photoModel = PhotoModel()
                    photoModel.setOriginalPath(mImgAdapter.data.get(i))
                    photos.add(photoModel)
                }
                bundle.putInt(PhotoPreviewActivity.IMAGE_POSITION, position)
                bundle.putSerializable(PhotoPreviewActivity.IMAGE_PHOTOS, photos)
                intent.putExtras(bundle)
                mContext.startActivity(intent)
            }
        }
    }
}