package com.pipipifa.pilaipiwang.goodselect.ui.adapter

import android.annotation.SuppressLint
import android.content.Intent
import android.os.Bundle
import androidx.recyclerview.widget.LinearLayoutManager
import androidx.recyclerview.widget.RecyclerView
import android.view.View
import android.widget.ImageView
import android.widget.LinearLayout
import android.widget.TextView
import com.chad.library.adapter.base.BaseViewHolder
import com.pipipifa.pilaipiwang.R
import com.pipipifa.pilaipiwang.goodselect.model.UselectGoodsImagesBean
import com.pipipifa.pilaipiwang.goodselect.utlis.BaseSingleAdapter
import com.pipipifa.pilaipiwang.photoselector.model.PhotoModel
import com.pipipifa.pilaipiwang.photoselector.ui.PhotoPreviewActivity
import com.ppwang.ppbase.utils.imageload.ImageUtils
import com.pipipifa.util.StringUtil
import java.util.ArrayList

class UselectRefundDetailAdapter : BaseSingleAdapter<UselectGoodsImagesBean>(R.layout.uselect_item_refund_detail) {
    @SuppressLint("SetTextI18n")
    override fun convert(helper: BaseViewHolder?, item: UselectGoodsImagesBean?) {
        var mImg: ImageView = helper!!.getView(R.id.iv_refund_detail_img)
        var mRecyclerView: androidx.recyclerview.widget.RecyclerView = helper.getView(R.id.rv_refund_detail_imglist)
        var mTvName: TextView = helper.getView(R.id.tv_refund_detail_name)
        var mTvPrice: TextView = helper.getView(R.id.tv_refund_detail_price)
        var mTvNum: TextView = helper.getView(R.id.tv_refund_detail_num)
        var mTvspecifications: TextView = helper.getView(R.id.tv_apply_refund_detail_specifications)
        var mllImgList: LinearLayout = helper.getView(R.id.ll_apply_refund_detail_imgList)
        ImageUtils.loadGlideRound(mContext, item?.coverPic, mImg, 4)
        mTvName.setText(item?.goodsName)
        mTvPrice.setText(StringUtil.RMB + item?.payPrice)
        mTvNum.setText(String.format("退款%s件", item?.totalNum))
        mTvspecifications.setText(item?.skuName)


        var mAdapter: UselectImageAdapter? = null;
        val linearLayoutManager = androidx.recyclerview.widget.LinearLayoutManager(mContext, androidx.recyclerview.widget.LinearLayoutManager.HORIZONTAL, false)
        mRecyclerView.layoutManager = linearLayoutManager
        mRecyclerView.adapter = mAdapter

        if (mRecyclerView.adapter == null) {
            mAdapter = UselectImageAdapter()
            mRecyclerView.adapter = mAdapter
        } else {
            mAdapter = mRecyclerView.adapter as UselectImageAdapter;
        }

        if (null != item?.imagesArray && item.imagesArray.size > 0) {
            mAdapter.data.clear()
            mllImgList.visibility = View.VISIBLE
            mAdapter.addData(item.imagesArray)
        } else {
            mllImgList.visibility = View.GONE
        }


        mAdapter.setOnItemClickListener { adapter, view, position ->
            if (mAdapter.data.size > 0) {
                val photos = ArrayList<PhotoModel>()
                val intent = Intent(mContext, PhotoPreviewActivity::class.java)
                val bundle = Bundle()
                for (i in mAdapter.data.indices) {
                    val photoModel = PhotoModel()
                    photoModel.setOriginalPath(mAdapter.data.get(i))
                    photos.add(photoModel)
                }
                bundle.putInt(PhotoPreviewActivity.IMAGE_POSITION, position)
                bundle.putSerializable(PhotoPreviewActivity.IMAGE_PHOTOS, photos)
                intent.putExtras(bundle)
                mContext.startActivity(intent)
            }
        }
    }
}