package com.pipipifa.pilaipiwang.goodselect.ui.adapter

import android.annotation.SuppressLint
import android.view.MotionEvent
import android.view.View
import android.widget.ImageView
import android.widget.TextView
import androidx.core.content.ContextCompat
import androidx.recyclerview.widget.LinearLayoutManager
import androidx.recyclerview.widget.RecyclerView
import com.chad.library.adapter.base.BaseViewHolder
import com.pipipifa.pilaipiwang.R
import com.pipipifa.pilaipiwang.goodselect.model.UselectReplacementListBean
import com.pipipifa.pilaipiwang.goodselect.utlis.BaseSingleAdapter
import com.ppwang.utils.StringFormatUtil


/**
 * @author: wangben
 * @date: 2020/4/17
 */
class UselectReplacemertAdapter : BaseSingleAdapter<UselectReplacementListBean>(R.layout.uselect_item_replacemert) {
    lateinit var mRecyclerview: RecyclerView
    lateinit var mAdapter: ReplacemertListAdapter
    lateinit var mIvType: ImageView
    lateinit var mTvName: TextView
    lateinit var mTvStatus: TextView
    lateinit var mTvFreight: TextView
    lateinit var mTvPrice: TextView


    @SuppressLint("SetTextI18n", "ClickableViewAccessibility")
    override fun convert(helper: BaseViewHolder?, item: UselectReplacementListBean?) {
        mRecyclerview = helper!!.getView(R.id.recyclerview)
        mTvName = helper!!.getView(R.id.tv_name)
        mTvStatus = helper!!.getView(R.id.tv_status)
        mTvFreight = helper!!.getView(R.id.tv_freight)
        mTvPrice = helper!!.getView(R.id.tv_price)

        mTvName.text = item?.sellerName
        mTvStatus.text = item?.flowStatusName
        mTvFreight.text = "共${item?.goodsTotal}件商品(含运费${item?.tipsMsg}元)"
        mTvPrice.text = "合计:${StringFormatUtil.getFormatPrice(item?.orderAmount!!, 18, 14, R.color.text_color_FFA02C)}"

        mRecyclerview.layoutManager = LinearLayoutManager(mContext)
        mAdapter = ReplacemertListAdapter()
        mRecyclerview.adapter = mAdapter
        mAdapter.setNewData(item?.goodsList!!)

        mRecyclerview.setOnTouchListener(object : View.OnTouchListener {
            override fun onTouch(v: View, event: MotionEvent): Boolean {
                return helper.itemView.onTouchEvent(event)
            }
        })

        when (item?.flowStatus) {
            "0" ,"1" -> {
                mTvStatus.setTextColor(ContextCompat.getColor(mContext, R.color.text_color_FF682F))
            }
            "2" -> {
                mTvStatus.setTextColor(ContextCompat.getColor(mContext, R.color.text_color_19B360))
            }
            "3" -> {
                mTvStatus.setTextColor(ContextCompat.getColor(mContext, R.color.red_color))
            }
            else -> {
                mTvStatus.setTextColor(ContextCompat.getColor(mContext, R.color.color_999999))
            }
        }

    }
}