package com.pipipifa.pilaipiwang.goodselect.ui.dialog

import android.content.Context
import androidx.recyclerview.widget.LinearLayoutManager
import androidx.recyclerview.widget.RecyclerView
import android.widget.TextView
import com.chad.library.adapter.base.BaseViewHolder
import com.pipipifa.pilaipiwang.R
import com.pipipifa.pilaipiwang.goodselect.model.UselectBaseDialogBean
import com.pipipifa.pilaipiwang.goodselect.utlis.BaseSingleAdapter
import com.pipipifa.pilaipiwang.ui.dialog.BaseDialog

/**
 * @author: wangben
 * @date: 2019/11/25
 */
class UselectBaseTextDialog : BaseDialog {
    lateinit var mRecyclerView: androidx.recyclerview.widget.RecyclerView
    lateinit var mTitle: TextView
    lateinit var mDismiss: TextView
    var mListener: OnTitleClickListener? = null
    var mAdapter: BaseDialogTextAdapter = BaseDialogTextAdapter()

    override fun getContentView(viewType: Int) = R.layout.uselect_dialog_base_text

    constructor(context: Context) : super(context, R.style.myDialogTheme2) {
        initView()
    }

    private fun initView() {
        mRecyclerView = findViewById(R.id.rv_dialog_base_text)
        mTitle = findViewById(R.id.tv_dialog_base_text_title)
        mDismiss = findViewById(R.id.tv_dialog_base_text_dismiss)
        mRecyclerView.layoutManager = androidx.recyclerview.widget.LinearLayoutManager(context)
        mRecyclerView.adapter = mAdapter
        mDismiss.setOnClickListener {
            dismiss()
        }
    }

    fun setOnTitleClickListener(listener: OnTitleClickListener) {
        this.mListener = listener
    }

    fun setTitleText(charSequence: CharSequence): UselectBaseTextDialog {
        mTitle.setText(charSequence)
        return this
    }

    fun addBaseBeanData(mBean: UselectBaseDialogBean) {
        mAdapter.addData(mBean)
        mAdapter.notifyDataSetChanged()
    }

    //inner  内部内调用外部的属性
    inner class BaseDialogTextAdapter : BaseSingleAdapter<UselectBaseDialogBean>(R.layout.uselect_item_base_dialog_text) {
        override fun convert(helper: BaseViewHolder?, item: UselectBaseDialogBean?) {
            var mContent: TextView = helper!!.getView(R.id.tv_dialog_base_text_content)
            mContent.setText(item!!.title)
            mContent.setOnClickListener {
                mListener?.onClick(item.id, item.title, item.type)
            }
        }
    }

    interface OnTitleClickListener {
        fun onClick(id: String, title: String, type: String)
    }
}