package com.pipipifa.pilaipiwang.goodselect.view

import android.content.Context
import android.graphics.drawable.BitmapDrawable
import android.util.AttributeSet
import android.view.LayoutInflater
import android.view.View
import android.widget.*
import com.pipipifa.pilaipiwang.R

class UselectTopbarRefundDetailView : RelativeLayout, View.OnClickListener {
    private var mTitle: TextView? = null
    private var mOnBackListener: OnBackClickListener? = null
    private var btnBack: ImageView? = null
    private val main: RelativeLayout? = null
    private var mContext: Context? = null
    private var mListner: MenuItemListener? = null
    private var isMenu = false
    private var moreLayout: View? = null
    private var popupWindow: PopupWindow? = null
    lateinit var mTvProcess: TextView
    lateinit var mTvRecord: TextView

    /**
     * popupWindow 内容宽度
     */
    private var mPopupContentViewWidth = 0

    val centerView: View?
        get() = main

    constructor(context: Context) : super(context) {
        init(context)
    }

    constructor(context: Context, attrs: AttributeSet) : super(context, attrs) {
        init(context)
    }

    private fun init(context: Context) {
        mContext = context
        View.inflate(context, R.layout.uselect_topbar_refund_detail_layout, this)
        moreLayout = findViewById(R.id.more_layout)
        moreLayout!!.setOnClickListener(this)
        mTitle = findViewById<View>(R.id.title) as TextView
        btnBack = findViewById<View>(R.id.back) as ImageView
        btnBack!!.setOnClickListener(this)
    }

    fun addOnBackClickListener(listener: OnBackClickListener) {
        this.mOnBackListener = listener
    }

    fun setTitle(title: String) {
        mTitle!!.text = title
    }

    override fun onClick(view: View) {
        when (view.id) {
            R.id.back -> if (mOnBackListener != null) {
                mOnBackListener!!.OnClick()
            }
            R.id.more_layout -> popupWindow!!.showAsDropDown(moreLayout,
                    -mPopupContentViewWidth + moreLayout!!.width,
                    5)
            else -> {
            }
        }
    }

    interface OnBackClickListener {
        fun OnClick()
    }

    fun showStore(userType: Int, refundType: Boolean, listener: MenuItemListener) {
        this.mListner = listener
        isMenu = true
        initDialog(userType, refundType)
    }

    private fun initDialog(userType: Int, refundType: Boolean) {
        val click = HandleMenuClick()
        val view = LayoutInflater.from(mContext).inflate(R.layout.uselect_menu_refund_detail_layout, null)
        // 手动调用measure测量view，提前获取view宽度
        view.measure(View.MeasureSpec.UNSPECIFIED, View.MeasureSpec.UNSPECIFIED)
        mPopupContentViewWidth = view.measuredWidth
        mTvRecord = view.findViewById(R.id.dialog_menu_consultation_record)
        mTvRecord.setOnClickListener(click)
        view.findViewById<View>(R.id.dialog_menu_order_detail).setOnClickListener(click)
        mTvProcess = view.findViewById(R.id.dialog_menu_refund_process)
        mTvProcess.setOnClickListener(click)

        if (userType == 0) {
            mTvProcess.visibility = View.GONE
        } else {
            mTvProcess.visibility = View.GONE
        }

        if (refundType) {
            mTvRecord.visibility = View.GONE
        } else {
            mTvRecord.visibility = View.VISIBLE
        }


        popupWindow = PopupWindow(view, LinearLayout.LayoutParams.WRAP_CONTENT, LinearLayout.LayoutParams.WRAP_CONTENT, true)
        popupWindow!!.isTouchable = true

        popupWindow!!.setTouchInterceptor { v, event ->
            false
            // 这里如果返回true的话，touch事件将被拦截
            // 拦截后 PopupWindow的onTouchEvent不被调用，这样点击外部区域无法dismiss
        }
        // 如果不设置PopupWindow的背景，无论是点击外部区域还是Back键都无法dismiss弹框
        // 我觉得这里是API的一个bug
        popupWindow!!.setBackgroundDrawable(BitmapDrawable())
    }


    interface MenuItemListener {
        // 协商记录
        fun onConsultationRecord()

        // 原订单详情
        fun onOrderDetail()

        fun onOrderProcess()
    }

    private inner class HandleMenuClick : OnClickListener {

        override fun onClick(view: View) {
            when (view.id) {
                R.id.dialog_menu_consultation_record -> if (mListner != null) {
                    mListner!!.onConsultationRecord()
                }
                R.id.dialog_menu_order_detail -> if (mListner != null) {
                    mListner!!.onOrderDetail()
                }
                R.id.dialog_menu_refund_process -> if (mListner != null) {
                    mListner!!.onOrderProcess()
                }
            }
            popupWindow!!.dismiss()
        }
    }
}