package com.pipipifa.pilaipiwang.net

import com.pipipifa.pilaipiwang.model.order.ShipmentsBean
import com.pipipifa.pilaipiwang.model.user.User
import com.ppwang.ppbase.base.net.param.ServerValue

/**
 * Anthor: 李东益
 * Date：2020/2/25
 * Description:
 */
class OrderApi {

    companion object {
        /**
         * app扫码发货列表（cmd=6543）
         */
        fun createRequest6550(user: User, invoiceNo: String): ServerValue {
            var param = ServerValue()
            param.cmd = Cmd.REQUEST_CODE_6550
            param.dataClass = ShipmentsBean::class.java
            param.addParam("store_id", user.userId)
            param.addParam("token", user.token)
            param.addParam("invoice_no", invoiceNo)
            if (user.isSubAccount) {
                param.addParam("sub_id", user.userId)
            }
            return param
        }

        /**
         * 41000 修改订单状态为支付中
         */
        @JvmStatic
        fun createRequest41000(user: User?, orderIds: ArrayList<String>): ServerValue {
            val param = ServerValue();
            param.cmd = Cmd.REQUEST_CODE_41000
            param.addParam("order_ids", orderIds)
            if (user != null) {
                param.addParam("user_id", user.userId)
                param.addParam("token", user.token)
            }
            return param
        }

    }


}