package com.pipipifa.pilaipiwang.ui.dialog

import android.content.Context
import android.widget.TextView
import androidx.recyclerview.widget.RecyclerView
import com.chad.library.adapter.base.BaseQuickAdapter
import com.chad.library.adapter.base.BaseViewHolder
import com.hjq.toast.ToastUtils
import com.pipipifa.pilaipiwang.R
import com.ppwang.ppbase.base.net.ApiURLConfig
import com.ppwang.ppbase.model.app.AppNet

/**
 * Anthor: 李东益
 * Date：2020/3/9
 * Description:
 */
class SwitchNetDialog: BaseDialog {

    private lateinit var rvList: RecyclerView
    private lateinit var adapter: NetAdapter

    constructor(context: Context?) : super(context) {
        initView()
    }

    /**
     * 初始化数据
     */
    private fun initView() {
        rvList = findViewById(R.id.rv_switch_net);
        rvList.layoutManager = androidx.recyclerview.widget.LinearLayoutManager(context)

        var arr = ArrayList<AppNet>()
        arr.add(AppNet("测试", ApiURLConfig.URL_TYPE_TEST, true))
        arr.add(AppNet("灰度", ApiURLConfig.URL_TYPE_ONLINE_TEST, false))
        arr.add(AppNet("RC", ApiURLConfig.URL_TYPE_TEST_RC, false))
        arr.add(AppNet("生产", ApiURLConfig.URL_TYPE_API2, false))
        adapter = NetAdapter(arr)
        rvList.adapter = adapter

        adapter.setOnItemClickListener { adapter, view, position ->
            var net = adapter.data.get(position);
            AppNet.save(context, net as AppNet)
            ToastUtils.show("地址成功切换，请重启app")
            dismiss()
        }

        var appNet = AppNet.get(context);
        ToastUtils.show("当前的环境：" + appNet.name)
    }

    override fun getContentView(viewType: Int): Int {
        return R.layout.dialog_switch_net
    }

    private class NetAdapter(arr: ArrayList<AppNet>) : BaseQuickAdapter<AppNet, BaseViewHolder>(R.layout.item_dialog_net, arr) {
        override fun convert(helper: BaseViewHolder?, item: AppNet?) {
            var tv = helper!!.getView<TextView>(R.id.tv_net_name);
            tv.setText(item!!.name)
        }
    }
}